/*
* 
* 5648-C83, 5648-C84 (C) COPYRIGHT International Business Machines Corp., 2007 
 * All rights reserved * Licensed Materials - Property of IBM  
 * 
 */
/* customizer javascript */

// TODO:  handle errors in AJAX, etc
// dojo.registerModulePath("com","../com");
/*TIP_DOJO_NS*/dojo.registerModulePath("com",contextRoot + "/secure/isclite/scripts/tipdojo/com");
/*TIP_DOJO_NS*/dojo.registerModulePath("ibm",contextRoot + "/secure/isclite/scripts/tipdojo/ibm");
/*TIP_DOJO_NS*/dojo.require("ibm.tivoli.tip.TIPDojoBase");
/*TIP_DOJO_NS*/dojo.require("dojo.dnd.Source"); // capital-S Source in 1.0
/*TIP_DOJO_NS*/dojo.require("dojo.parser");  
/*TIP_DOJO_NS*/dojo.require("dojo.dnd.autoscroll"); // TEMP for porting - prob not needed once wiring is ported


var customizer = {
	tempResizeStore: {},
	isRTL: {}, //239473 define isRTL for customizer
	pagesInCustomMode : [],
	piiContainerArray : [],
	reloadStoreData: false ,
	maximizedPortlets: [],
	restoredPortlet: null,
	personalResizeStore: {},
	nlsResources: {},

	/*248488*/
	sizePortletDiv: function( portletDiv, w, h ) {
		var METHODNAME = "sizePortletDiv ";
		//console.log( METHODNAME + "Entry, " + portletDiv.id + " " + w + "," + h );

		if("undefined" === typeof iscPortlet) return;
		if( typeof( w ) != 'undefined' && w != null ) {
			if( typeof(w) == 'string' ) w = parseInt( w );
			w >= 0 && /*TIP_DOJO_NS*/dojo.style( portletDiv, "width", w+"px" );
		}
		if( typeof( h ) != 'undefined' && h != null && h != 0) {
			if( typeof(h) == 'string' ) h = parseInt( h );

			var v = /*TIP_DOJO_NS*/dojo.byId("iscPortlet_;"+portletDiv.id+";view");
			var isMinimized = v && v.modelObject && v.modelObject.portletData.state === "minimized";
			
			//portletDiv.style.height = h + "px";
			if(isMinimized) {
			  if (portletDiv.style.height != "") {
			    portletDiv.prevHeight = (parseInt(portletDiv.style.height) - 3) + "px";
			  }

			  /* 254951, 254951f_2
			   * For embeded object(s), e.g. Applet, overflow: hidden;
			   * may cause the object(s) being re-inited, just like
			   * what display: none; will do.
			   */
			  var containsObjects = customizer.hasObjectEmbeded(portletDiv);
			  /*TIP_DOJO_NS*/ dojo.style( portletDiv, {height: "", overflow: containsObjects ? "" : "hidden"});
			}
			else
			{
				h >= 0 && /*TIP_DOJO_NS*/dojo.style( portletDiv, {height: h+"px", overflow: "auto"} );
			}
			var availableHeight = h;

			var titleCell = document.getElementById( "isc-portlet-titlebar" + portletDiv.id );
			var titleTable = /*TIP_DOJO_NS*/dojo.query( "table", titleCell )[0];
			var portletTable = titleCell.parentNode.parentNode.parentNode;
			var iscPortletTableCell = portletTable.parentNode.parentNode;
			var iscPortletTable = iscPortletTableCell.parentNode.parentNode;

			var portletContentCell = document.getElementById( "isc-portlet-bkg" + portletDiv.id );

			//var iscPortletTableCellPadding = iscPortlet.getPadding( iscPortletTableCell );
			var iscPortletTablePadding = iscPortlet.getPadding( iscPortletTable );

			//var titleCoords = /*TIP_DOJO_NS*/dojo.coords( titleCell );
			var titleCellPadding = iscPortlet.getPadding( titleCell );
			var titleTableCoords = /*TIP_DOJO_NS*/dojo.coords( titleTable );

			var titleHeight = titleTableCoords.h + titleCellPadding.t + titleCellPadding.b + 1;
			//console.log( METHODNAME + "titleHeight: " + titleHeight );

			availableHeight -= titleHeight;

			var iscPortletTablePaddingHeight = iscPortletTablePadding.t + iscPortletTablePadding.b;
			//availableHeight -= iscPortletTableCellPadding.t + iscPortletTableCellPadding.b;
			//console.log( METHODNAME + "iscPortletTablePaddingHeight: " + iscPortletTablePaddingHeight );

			availableHeight -= iscPortletTablePaddingHeight;

			//console.log( METHODNAME + "availableHeight: " + availableHeight );

			var altAvailableHeight = iscPortlet.getPortletSize( portletDiv ).available.h;
			//console.log( METHODNAME + "altAvailableHeight: " + altAvailableHeight );

			availableHeight = Math.max( availableHeight, altAvailableHeight );

			//251528
			if( /*TIP_DOJO_NS*/dojo.isIE ) {
				//console.log( METHODNAME + "Removing 4 extra pixels added in Claro switch" );
				availableHeight -= 4;
			}


			//portletTable.style.height = availableHeight;
			
			
			
			if(isMinimized) {
				/*TIP_DOJO_NS*/dojo.style(portletContentCell, "height", "");
				portletContentCell.setAttribute( "height", "" );
			}
			else {
				availableHeight >= 0 && /*TIP_DOJO_NS*/dojo.style(portletContentCell, "height", availableHeight + "px");
				portletContentCell.setAttribute( "height", availableHeight + "px" );
			}
			
			var contentIsolationIframe = document.getElementById( portletDiv.id + "_iframe" );
			if( typeof( contentIsolationIframe ) != 'undefined' && contentIsolationIframe != null && availableHeight > 0) {
				contentIsolationIframe.style.height = availableHeight + "px";
				contentIsolationIframe.setAttribute( "height", availableHeight + "px" );
			}
		}

		//console.log( METHODNAME + "Exit" );
	},
	
	/**
	 * Determine whether any object(s) is embeded
	 * in the given element.
	 */
	hasObjectEmbeded: function(rootEl) {
		if(!rootEl || !rootEl.getElementsByTagName) {
			return false;
		}
		
		return (
			rootEl.getElementsByTagName('object').length > 0 ||
			rootEl.getElementsByTagName('embed').length > 0 ||
			rootEl.getElementsByTagName('applet').length > 0
		);
	},

	getAncestors: function(/*Node*/node, /*function?*/filterFunction, /*boolean?*/returnFirstHit){
		//  summary:  (abandoned by dojo 0.9.0)
		//      returns all ancestors matching optional filterFunction; will return
		//      only the first if returnFirstHit
		var ancestors = [];
		var isFunction = (filterFunction && (filterFunction instanceof Function || typeof filterFunction == "function"));
		while(node){
			if(!isFunction || filterFunction(node)){
				ancestors.push(node);
			}
			if(returnFirstHit && ancestors.length > 0){
				return ancestors[0];    //  Node
			}
			node = node.parentNode;
		}
		if(returnFirstHit){ return null; }
		return ancestors;   //  array
	},
	getAncestorsByTag: function(/*Node*/node, /*String*/tag, /*boolean?*/returnFirstHit){
		//  summary: (abandoned by dojo 0.9.0)
		//      returns all ancestors matching tag (as tagName), will only return
		//      first one if returnFirstHit
		tag = tag.toLowerCase();
		return customizer.getAncestors(node, function(el){
			return ((el.tagName)&&(el.tagName.toLowerCase() == tag));
		}, returnFirstHit); //  Node || array
	},
	getFirstAncestorByTag: function(/*Node*/node, /*string*/tag){
		//  summary:  (abandoned by dojo 0.9.0)
		//      Returns first ancestor of node with tag tagName
		return customizer.getAncestorsByTag(node, tag, true); //  Node
	},
	getPreviousSiblingElement: function(/* Node */node, /* string? */tagName){
		//  summary: (abandoned by dojo 0.9.0)
		//      returns the previous sibling element matching tagName
		if(!node) { return null; }
		if(tagName) { tagName = tagName.toLowerCase(); }
		do {
			node = node.previousSibling;
		} while(node && node.nodeType != 1);
		if(node && tagName && tagName.toLowerCase() != node.tagName.toLowerCase()) {
			return customizer.getPreviousSiblingElement(node, tagName);
		}
		return node;    //  Element
	},
	replaceNode: function(/*Element*/node, /*Element*/newNode){
    	//  summary:  (abandoned by dojo 0.9.0)
    	//      replaces node with newNode and returns a reference to the removed node.
    	//      To prevent IE memory leak, call destroyNode on the returned node when
    	//      it is no longer needed.
    	return node.parentNode.replaceChild(newNode, node); // Node
	},
	getNextSiblingElement: function(/* Node */node, /* string? */tagName){
		//  summary:  (abandoned by dojo 0.9.0)
		//      returns the next sibling element matching tagName
		if(!node) { return null; }
		do {
			node = node.nextSibling;
		} while(node && node.nodeType != 1);
		if(node && tagName && tagName.toLowerCase() != node.tagName.toLowerCase()) {
			return customizer.getNextSiblingElement(node, tagName);
		}
		return node;    //  Element
	},
    
	showTable:function(uniquePageName){
		var buttonId = uniquePageName +"_wires_button_id";
		var wireButton = /*TIP_DOJO_NS*/dojo.byId(buttonId);
		/*TIP_DOJO_NS*/dojo.addClass(wireButton,'isc-table-toolbar-buttonbar-hide');

		var div = /*TIP_DOJO_NS*/dijit.byId(uniquePageName+"_Wires_Table_ID").domNode;
		/*TIP_DOJO_NS*/dojo.addClass(div,"tipEventsandWires");

		var pageDiv = IscPages.getPageElementById(IscPages.currentPageId);
		var palette = dijit.byId(pageDiv.modelObject.pageData.uid + "palette");
		if(palette) {
			palette.hide(true);
		}
		expandTable= function(/*Object*/ args){
			// summary
			//		Returns an animation that will expand the
			//		node defined in 'args' object from it's current height to
			//		it's natural height (with no scrollbar).
			//		Node must have no margin/border/padding.
			args.node = /*TIP_DOJO_NS*/dojo.byId(args.node);
			var node = args.node, s = node.style;

			var anim = /*TIP_DOJO_NS*/dojo.animateProperty(/*TIP_DOJO_NS*/dojo.mixin({
				properties: {
					height: {
						// wrapped in functions so we wait till the last second to query (in case value has changed)
						start: function(){
							// start at current [computed] height, but use 1px rather than 0
							// because 0 causes IE to display the whole panel
							s.overflow="hidden";
							if(s.visibility=="hidden"||s.display=="none"){
								s.height="1px";
								s.display="";
								s.visibility="";
								return 1;
							}else{
								var height = /*TIP_DOJO_NS*/dojo.style(node, "height");
								return Math.max(height, 1);
							}
						},
						end: function(){
							return node.scrollHeight;
						}
					}
				}
			}, args));
			/*TIP_DOJO_NS*/dojo.connect(anim, "onEnd", function(){ 
				s.height = "auto";
				s.overflow="";
				// resize page contents once the animation is finished
				//246121 - WireGUI: portlet size reduce after show wires in custom page
//				var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
//				customizer.rescaleRelativePage( pageDiv );
//				if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'show wires table' );
				//End 246121 - WireGUI: portlet size reduce after show wires in custom page
				
				this.node.focus();
			});
			return anim; // dojo._Animation
		}	
		expandTable({ node: div, left:"0", top:"50", unit:"px" }).play(); 
     },
    
    destroyWireTable:function(uniquePageName){
	   var table = /*TIP_DOJO_NS*/dijit.byId(uniquePageName+"_Wires_Table_ID");
	   
	   
       if(table){
           table.destroy();
       }
    },
    
    setupWiresTable:function(pageDiv){
        
        var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
	this.destroyWireTable(uniquePageName);
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId);
		var store = storeManager.getWiresStore();
        var tableId = uniquePageName+"_Wires_Table_ID";
        var table = /*TIP_DOJO_NS*/dijit.byId(tableId);
        
		var tableParent = /*TIP_DOJO_NS*/dojo.byId(pageDiv.modelObject.pageData.uid+ "_wires_table_id");
         
       // if(table == null){
			var nodeRef = document.createElement("div");
			tableParent.appendChild(nodeRef);
            table = new com.ibm.isclite.dijit.custom.wires.WiresTable( {
                wireTypeTableLabel               :eventsAndWiresNls.wiresTable.wireTypeLabel,
                sourceLabel                 :eventsAndWiresNls.wiresTable.sourceLabel,
                eventLabel                  :eventsAndWiresNls.wiresTable.eventLabel,
                targetLabel                 :eventsAndWiresNls.wiresTable.targetLabel,
                transformLabel              :eventsAndWiresNls.wiresTable.transformLabel,
                enableLabel                 :eventsAndWiresNls.wiresTable.enableLabel,
                deletedLabel                :eventsAndWiresNls.wiresTable.deletedLabel,
                noTransformLabel            :eventsAndWiresNls.wiresTable.noTransformationLabel,
                wiresTableDescriptionLabel  :eventsAndWiresNls.wiresTable.wiresTableDescriptionLabel,
                newLabel                    :eventsAndWiresNls.wiresTable.newLabel,
                wiresTableTitlelabel        :eventsAndWiresNls.wiresTable.wiresTableTitlelabel,
                closeLabel                  :eventsAndWiresNls.wiresTable.closeLabel,
                totalLabel                  :eventsAndWiresNls.wiresTable.totalLabel,
                targetButtonTitle           :eventsAndWiresNls.wiresTable.targetButtonTitle,
                transformationButtonTitle   :eventsAndWiresNls.wiresTable.transformationButtonTitle,
                deleteTitle                 :eventsAndWiresNls.wiresTable.deleteTitle,
                enableTitle                 :eventsAndWiresNls.wiresTable.enableTitle,
				wireTypeCustom          :eventsAndWiresNls.wiresTable.wireTypeCustom,
				wireTypeSystem         :eventsAndWiresNls.wiresTable.wireTypeSystem,
                
                store                       :store,
                labelAttr                   :"name",
                uniquePageName              :uniquePageName,
                storeManager                :storeManager,
                query                       :{type:'wire'},
                id                          :tableId,childrenAttr:"params"},
                nodeRef);
      //  }
	
	
	
	/*if(tableParent!=table.domNode.parentNode){
		
			var oldTableParent = table.domNode.parentNode;
			oldTableParent.removeChild(table.domNode);
            tableParent.appendChild(table.domNode); 
		
	
	}	*/
	
        table.domNode.style.display="none";
	
	
    },

	saveUserSizePortletData: function( pageId ) {
    	var mo;
		if ( ! customizer.personalResizeStore[pageId] ) return;
		var pages = /*TIP_DOJO_NS*/dojo.query( 'div[name="IscPage"]', document );
		for ( var i=0; i<pages.length; i++ ) {
			mo = pages[i].modelObject;
			if ( mo && pages[i].modelObject.getPageUID() == pageId ) { // check for multipletons
				var portlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', pages[i] );
				for ( var h=0; h<portlets.length; h++ ) {
					var pii = portlets[h].modelObject.portletData.basePii;
					if ( customizer.personalResizeStore[pageId][pii] ) {
						portlets[h].modelObject.portletData.userPortletSize = customizer.personalResizeStore[pageId][pii];
					}
				}
			}
		}
	},
	saveUserPortletSizes: function() {
		// onclick function for resizer Save button
		var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var pageId = pageDiv.modelObject.getPageUID();
		var url = contextRoot + '/ppa.do?action=save&pageid=' + pageId+"&XSS="+top.window.XSS;
		// need to save all porlet sizes so they scale the same
		// rather than just the customized ones

		var processingPortlet = null;
			var element = null;
			var counter = 0;
			var pii = null;
		 var portlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', pageDiv );
		for ( var i=0; i<portlets.length; i++ ) {
			 processingPortlet = portlets[i];
			 element = null;
			 counter = i + 1;
			 pii = processingPortlet.modelObject.portletData.basePii;

			element = processingPortlet.parentNode;
			url += '&pii' + counter + '=' + pii
				+ 'X' + parseInt( processingPortlet.parentNode.style.width )
				+ 'Y' + parseInt( processingPortlet.parentNode.style.height );
		}

		url = encodeURI( url );
		// enable restore button
		var restoreButton = /*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.restore"]', pageDiv )[0];
		restoreButton.style.display = "inline";
		if ( ! restoreButton.clickevent ) {
			restoreButton.clickevent = /*TIP_DOJO_NS*/dojo.connect( restoreButton, "onclick", customizer, "restoreUserPortletSizes" );
		}
		// disable save and cancel buttons
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.save"]', pageDiv )[0].style.display = "none";
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.cancel"]', pageDiv )[0].style.display = "none";
		// put the new sizes into the personalResizeStore for the page
		customizer.personalResizeStore[pageId] = customizer.tempResizeStore[pageId];
		customizer.saveUserSizePortletData( pageId );
		// remove the temp sizes for this page
		delete( customizer.tempResizeStore[pageId] );
		// send the new sizes to the server
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text"
		} );
	},
	cancelUserPortletSizes: function() {
		// restore to previously saved personal sizes or global sizes - onclick for Cancel button
		// -------------------------------------------------------------------------
		// I don't think I need to do anything with the server for cancel.
		// It's only active when someone is resizing and has not saved so the server doesn't
		// know that any resizing has been done anyway...
		// example url: contextRoot + /ppa.do?action=cancel&pageid=1&pii1=2346X213Y215&pii2=6787X214Y216
		// -------------------------------------------------------------------------
		var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var pageId = pageDiv.modelObject.getPageUID();
		// remove the temp sizes for this page
		delete( customizer.tempResizeStore[pageId] );
		// disable save and cancel buttons
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.save"]', pageDiv )[0].style.display = "none";
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.cancel"]', pageDiv )[0].style.display = "none";
		// restore portlets back to the original percents that were served up initially
		customizer.restorePortletSizes( pageDiv );
	},
	restoreUserPortletSizes: function() {
		var METHODNAME = "restoreUserPortletSizes ";
		// revert all portlet sizes back to global sizes - onclick for Restore button
		//
		// this now needs to set all portlets back to the global pixel sizes:
		// calculate the percents, set them, then rescale.
		// need to also set the params as if loaded initially
		//
		var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var pageId = pageDiv.modelObject.getPageUID();
		var url = contextRoot + '/ppa.do?action=restore&pageid=' + pageId +"&XSS="+top.window.XSS;
		var counter=1;
		for ( pii in customizer.personalResizeStore[pageId] ) {
			url += '&pii' + counter + '=' + pii;
			counter++;
		}
		url = encodeURI( url );
		// remove temp and personal size objects
		delete( customizer.personalResizeStore[pageId] );
		delete( customizer.tempResizeStore[pageId] );

		var rootTable = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if (rootTable != null){
		  //  var freeFormContent = /*TIP_DOJO_NS*/dojo.byId(IscPages.currentPageId + "FreeformContent");
			//freeFormContent.style.width = '1px';
			//freeFormContent.style.height = '1px';
		//}else{
			// squash the table so that sizes will grow properly
			rootTable.style.width = '1px';
			rootTable.style.height = '1px';
			/*
			rootTable.tBodies[0].style.width = '1px';
			rootTable.tBodies[0].style.height = '1px';
			*/
		}

		// delete user size from portlet data object - handle SM multipletons
	   // var pages = /*TIP_DOJO_NS*/dojo.query( 'div[name="IscPage"]', document );
		//for ( var i=0; i<pages.length; i++ ) {
		   // if ( pages[i].modelObject.getPageUID() == pageId ) { // check for multipletons
				// set all the px sizes, calc the percents, rescale the page
				pageDiv.modelObject.pageData.percentsSet = false;
				var processingPortlet = null;
				var size =null;
				var element =null;
				var portlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', pageDiv );
				for ( var h=0; h<portlets.length; h++ ) {
					processingPortlet = portlets[h];
					// set all sizes on the first pass
					processingPortlet.modelObject.portletData.userPortletSize = false; // unset portletData
					size = processingPortlet.modelObject.portletData.globalPortletSize;
					if (pageDiv.modelObject.pageData.layoutType != "Freeform") {
						element = processingPortlet.parentNode;
						element.style.width = size[0] + "px";
						element.style.height = size[1] + "px";
					}
					else{
						element = processingPortlet.parentNode.parentNode;
						element.style.width = size[0] + "px";
						element.style.height = size[1] + "px";
						element.style.left = size[2] + "px";
						element.style.top = size[3] + "px";
						element.style.zIndex = size[4];
					}
				}
				for ( var h=0; h<portlets.length; h++ ) {
					// set all percents on the second pass
					customizer.calcRelativePortletPercent( portlets[h].parentNode );
				}
				// convert the the percents from above into actual pixel sizes
				customizer.rescaleRelativePage( pageDiv );
				pageDiv.modelObject.pageData.percentsSet = true;
			//}
		//}
		// disable all three buttons
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.save"]', pageDiv )[0].style.display = "none";
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.cancel"]', pageDiv )[0].style.display = "none";
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.restore"]', pageDiv )[0].style.display = "none";
		if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer restoring to global sizes' );
		// tell the server to restore the page
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text",
			preventCache: true
		} );
	},
	checkForUserSizedPortlets: function( pageDiv ) {
		var pageId = pageDiv.modelObject.getPageUID();
		var portlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', pageDiv );
		var rv = false;
		for ( var i=0; i<portlets.length; i++ ) {
			var pii = portlets[i].modelObject.portletData.basePii;
			if ( portlets[i].modelObject.portletData.userPortletSize ) {
				rv = true;
				if ( ! customizer.personalResizeStore[pageId] ) {
					// create personal size store
					customizer.personalResizeStore[pageId] = {};
				}
				customizer.personalResizeStore[pageId][pii] = portlets[i].modelObject.portletData.userPortletSize;
			}
		}
		return rv;
	},
	enterResizeMode: function( pageDiv ) {
		// enter resize-only mode
		var pageId = pageDiv.modelObject.getPageUID();
		customizer.displaySizers( pageDiv );
		// initialize relative sizes and do initial scaling
		customizer.makePageRelative( pageDiv );
		customizer.hideSizeButtons( pageDiv ); // reset the buttons - for SM multipleton pages
		var resizeButtonCell = /*TIP_DOJO_NS*/dojo.query( 'td[id="resizer-button-cell"]', pageDiv )[0];
		/*TIP_DOJO_NS*/dojo.removeClass( resizeButtonCell, 'isc-table-toolbar-buttonbar-resizer-hide' );
		/*TIP_DOJO_NS*/dojo.addClass( resizeButtonCell, 'isc-table-toolbar-buttonbar-resizer' );
		if ( customizer.checkForUserSizedPortlets( pageDiv ) ) {
			// see if there are user sizes and enable restore button
			var restoreButton = /*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.restore"]', pageDiv )[0];
			restoreButton.style.display = "inline";
			if ( ! restoreButton.clickevent ) {
				restoreButton.clickevent = /*TIP_DOJO_NS*/dojo.connect( restoreButton, "onclick", customizer, "restoreUserPortletSizes" );
			}
         if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'restoring portlet sizes' );
		}
		if ( customizer.tempResizeStore[pageId] ) {
			// restore temp sizings that where not saved
			// TODO: this also happens in makePageRelative(). check if this is a dup.
			customizer.restorePortletSizes( pageDiv );
			customizer.initResizeSaveCancel( pageDiv );
		}
		// add mouse-over tip for grabbie images in the sizer bars
		var pageRole = pageDiv.modelObject.getPageRoleAccess(); // this is only used for titles so it's ok to not be very secure
		var title = '';
		if ( pageRole == 'Editor' ) {
			title = customizer.nlsResources['customizer.resize.sizerbar.edit'];
		} else if ( pageRole == 'Privileged User' ) {
			title = customizer.nlsResources['customizer.resize.sizerbar.pu'];
		}
		var sizers = /*TIP_DOJO_NS*/dojo.query( 'td[name="IscSizebar"] img', pageDiv );
		for ( var i=0; i<sizers.length; i++ ) {
			sizers[i].title = title;
		}
	},
	convertPersonalSizesToGlobal: function( pageDiv, sizeObject ) {
		// for any portlets have personal sizes (saved or unsaved), submit the size changes
		// to the customizer ajax server to make them into global size changes
		var portlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', pageDiv );
		for ( var i=0; i<portlets.length; i++ ) {
			var pii = portlets[i].modelObject.portletData.basePii;
			if ( sizeObject && sizeObject[pii] ) {
				var div = customizer.getContainingPortlet( portlets[i] );
				customizer.sendPortletSize( div );
			}
		}
		var pageId = pageDiv.modelObject.getPageUID();
		// remove either personal or temp size stores for the page
		delete( customizer.tempResizeStore[pageId] );
		delete( customizer.personalResizeStore[pageId] );
	},
	restorePortletSizes: function( pageDiv ) {
		// use percents rather that pixel sizes to restore
		// this is called from:
		//
		// makePageRelative - to restore any temporary (unsaved) personal sizings for nonSM pages
		// cancelUserPortletSizes - from Cancel button - restore either to global or saved personal settings
		// deleteUserSizePortletData - restore to global settings
		// enterResizeMode - to restore any temporary (unsaved) personal sizings for nonSM pages
		//     is this last one a duplicate from makePageRelative???
		var pageId = pageDiv.modelObject.getPageUID();
		var portlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', pageDiv );
		for ( var i=0; i<portlets.length; i++ ) {
			var processingPortlet = portlets[i];
			if("minimized" == processingPortlet.modelObject.portletData.state)
				// don't try to restore the size of a minimized portlet
				continue;
			var pii = processingPortlet.modelObject.portletData.basePii;
			if ( customizer.tempResizeStore[pageId] && customizer.tempResizeStore[pageId][pii] ) {
				// set percent to the ones from the temp storage if it exists
				processingPortlet.parentNode.percent.w = customizer.tempResizeStore[pageId][pii][2];
				processingPortlet.parentNode.percent.h = customizer.tempResizeStore[pageId][pii][3];
			} else {
				// set percent to stored global percent size
				if (pageDiv.modelObject.pageData.layoutType != "Freeform") {
				processingPortlet.parentNode.percent.w = processingPortlet.modelObject.portletData.initialPercents[0];
				processingPortlet.parentNode.percent.h = processingPortlet.modelObject.portletData.initialPercents[1];
				}
				else{
					var size = processingPortlet.modelObject.portletData.globalPortletSize;

					processingPortlet.parentNode.parentNode.style.width = size[0] + "px";
					processingPortlet.parentNode.parentNode.style.height = size[1] + "px";
					processingPortlet.parentNode.parentNode.style.left = size[2] + "px";
					processingPortlet.parentNode.parentNode.style.top = size[3] + "px";
					processingPortlet.parentNode.parentNode.style.zIndex = size[4];
				}
			}
		}
		// apply all the percents we just set
		customizer.rescaleRelativePage( pageDiv );
		// send event and trigger fixPortletSizes
		if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'restoring portlet sizes' );
	},
	initResizeSaveCancel: function( pageDiv ) {
		var saveButton = /*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.save"]', pageDiv )[0];
		saveButton.style.display = "inline";
		if ( ! saveButton.clickevent ) {
			saveButton.clickevent = /*TIP_DOJO_NS*/dojo.connect( saveButton, "onclick", customizer, "saveUserPortletSizes" );
		}
		var cancelButton = /*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.cancel"]', pageDiv )[0];
		cancelButton.style.display = "inline";
		if ( ! cancelButton.clickevent ) {
			cancelButton.clickevent = /*TIP_DOJO_NS*/dojo.connect( cancelButton, "onclick", customizer, "cancelUserPortletSizes" );
		}
	},
	hideSizeButtons: function(pageDiv){
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.save"]', pageDiv )[0].style.display = "none";
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.cancel"]', pageDiv )[0].style.display = "none";
		/*TIP_DOJO_NS*/dojo.query( 'input[name="page.resize.restore"]', pageDiv )[0].style.display = "none";
	},

	displaySizers: function( pageDiv ) {
		if(pageDiv.modelObject && "User" == pageDiv.modelObject.getPageRoleAccess())
			return;	// don't show sizers for plain old "Users"
		
		var layoutRoot = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if ( !layoutRoot ) {
			//console.error( "error: layout root not found" );
			return;
		}
		// find, attach event handler, and display sizer bars
		dojo.forEach(UIElement.getElementsByName( layoutRoot, "IscSizebar" ), function( i ) 
		{
			dojo.style( i, 'display', '' );
			dojo.style( i, 'visibility', 'visible' );	// isc_workpage.css defaults visibility: hidden. make visible for Editors and Privliged Users
			if ( ! i.event ) {
				// TODO: I can't find any place where this is disconnected
				i.event = dojo.connect( i, "onmousedown", customizer, "sizeMouseDown" );
			}
		});
	},
	enterPersonalizeModeFromMenu: function( pageDiv, bool) {
		customizer.enterPersonalizeMode( pageDiv, bool);
	},
	enterCustomizeModeFromMenu: function( pageDiv ) {
		// this is called from the taskbar dropdown "Edit Page.." entry
		// alerts the server that the page is to be customized and
		// calls enterCustomizeMode()
		var uid = pageDiv.modelObject.pageData.tid;
		var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
		if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
			uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
		var url = contextRoot + '/customizer.do?action=edit'
					+ '&moduleRef=' + pageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + uniquePageName
					+ '&windowId=' + '000' // there's no specific window, but we have to send something
					+ '&edit=true' +"&XSS="+top.window.XSS;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text"
		} );
		pageDiv.modelObject.setPageInEditMode( true );
		customizer.enterCustomizeMode( pageDiv );
		
	},
	enterSaveAsFromMenu:function( pageDiv ){
         var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
		
		var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId); 
		if (storeManager){
			eventsAndWiresUW = storeManager.getUnitOfWork("ISC.saveAsNewPage");
        }
		var eventsAndWiresArray = new Array();
		eventsAndWiresArray["eventsAndWiresUW"] = /*TIP_DOJO_NS*/dojo.toJson(eventsAndWiresUW);
		var content=eventsAndWiresArray;
		var location = contextRoot + '/taskbarfragment.do?ISC.saveAsNewPage='+pageDiv.modelObject.pageData.uid +"&XSS="+top.window.XSS;

        var layoutType = pageDiv.modelObject.pageData.layoutType;
		// if page is freeform then let's get the coordinates of the windows so that we can save them
		if (layoutType == "Freeform"){
			var coordinates="&tip.windowCoordinates=";
			var contentInfo="";
			var portlets = Portlet.getPortletElements(pageDiv );
			var counter = 0;
			var pii = null;
			var processingPortlet = null;

			for ( var i=0; i<portlets.length; i++ ) {
				processingPortlet = portlets[i];
				counter = i + 1;
				pii = processingPortlet.id;
				contentInfo += '|' + pii
					+ ';' + parseInt( processingPortlet.style.left )
					+ ';' + parseInt( processingPortlet.style.top )
					+ ';' + parseInt( processingPortlet.style.zIndex )
            		+ ';' + parseInt( processingPortlet.style.height )
					+ ';' + parseInt( processingPortlet.style.width );
			}

			coordinates +=contentInfo;
			location +=coordinates;
		}
		SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);
	},
	enterPersonalizeMode: function( pageDiv, bool ) {
		pageDiv.modelObject.setPageInPersonalizeMode( bool );
		return;
	},
	enterCustomizeMode: function( pageDiv ) {
		// puts the page visuals into customize mode
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;
		pageDiv.modelObject.pageData.noSize = false;

		// If the page is already showing edit mode, do nothing
		if( pageDiv.modelObject.isPageShowingEditMode() ) return;

		customizer.hideSizeButtons(pageDiv);
		pageDiv.modelObject.setPageShowingEditMode( true );

		var pageId = pageDiv.modelObject.getPageUID();
		// check to see if there are any personalized sizes for this page
		// (either saved or unsaved) and send them to the server as global
		// customizer size changes.
		if ( customizer.tempResizeStore[pageId] ) {
			// the page has personalized portlet sizes that were unsaved/in process
			customizer.convertPersonalSizesToGlobal( pageDiv, customizer.tempResizeStore[pageId] );
		} else if ( customizer.checkForUserSizedPortlets( pageDiv ) ) {
			// the page has personalized portlet sizes that were saved
			customizer.convertPersonalSizesToGlobal( pageDiv, customizer.personalResizeStore[pageId] );
		}

		customizer.displaySizers( pageDiv );

		// replace any titles from sizer bars that were put there in the personal resizer
		/*TIP_DOJO_NS*/dojo.query( 'td[name="IscSizebar"] img', pageDiv ).forEach(
			"item.title = customizer.nlsResources['customizer.resize.sizerbar.customizemode']"
		);

		// toggle display of save/cancel buttons for this page
		/*TIP_DOJO_NS*/dojo.query( 'td.isc-table-toolbar-buttonbar-hide', pageDiv ).forEach(
			function( i ) {
				/*TIP_DOJO_NS*/dojo.removeClass( i, 'isc-table-toolbar-buttonbar-hide' );
				/*TIP_DOJO_NS*/dojo.addClass( i, 'isc-table-toolbar-buttonbar' );
			}
		);
		// toggle display of wires buttons for this page
		/*TIP_DOJO_NS*/dojo.query( 'input.isc-table-toolbar-buttonbar-hide', pageDiv ).forEach(
			function( i ) {
				/*TIP_DOJO_NS*/dojo.removeClass( i, 'isc-table-toolbar-buttonbar-hide' );
				/*TIP_DOJO_NS*/dojo.addClass( i, 'isc-table-toolbar-buttonbar' );
			}
		);	

		// initialize sizing just in case it isn't
		if ( ! pageDiv.modelObject.pageData.percentsSet ) {
			customizer.makePageRelative( pageDiv );
		} else {
			// audit portlet sizes and notify portlets
			if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer.enterCustomizeMode()' );
		}

		// toggle display of items in dropdown menu
		// there is an IE bug (since 2003) that stops this working in all versions of IE
		// see:   http://codylindley.com/Webdev/315/ie-hiding-option-elements-with-css-and-dealing-with-innerhtml
		//        http://support.microsoft.com/default.aspx?scid=kb;en-us;276228
		// rather than mucking around in the DOM, for now, leaving it...
		var dropDownMenu = null;
		if (parent.taskbar./*TIP_DOJO_NS*/dojo != null) {
			dropDownMenu = parent.taskbar./*TIP_DOJO_NS*/dojo.byId( 'PageAction' );
		}
		if (dropDownMenu != null) {
			dropDownMenu.selectedIndex = 0;
			for ( var i=0; i<dropDownMenu.options.length; i++ ) {
				if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-hide' ) {
					dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-show';
				} else if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-show' ) {
					dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-hide';
				}
			}
		}
		this.initEventsAndWiresClasses();
		this.setupEventsAndWiresStoreManager(pageDiv);
		//this.setupWiresDragAndDrop( pageDiv );
		this.setupWiresTable(pageDiv);
		this.setupEventsAndWiresController(pageDiv);
		this.reloadStoreData=false;
		var portlets = UIElement.getElementsByName( pageDiv, "PortletFragment" );
		for ( var i=0; i<portlets.length; i++ ) {
			//this.setupPorltetWiresDragAndDrop( portlets[i] );  
			customizer.putPortletInCustomizeMode( portlets[i] );
		}
		if (pageDiv.modelObject.pageData.layoutType == "Freeform"){
			//253940
//			var ffportlets = dojo.query(".tip-portlet", pageDiv);
//		  for ( var i=0; i<ffportlets.length; i++ ) {
//			  this.setupPorltetWiresDragAndDrop( ffportlets[i] );
//		  }
		  
			//Defect 253489
		    var widgets = Portlet.getPortletElements(pageDiv);
			for ( var x=0; x<widgets.length; x++ ) {
				var w = dijit.byId(widgets[x].id);
				if(w) {
					w.domNode.modelObject.updatePortletForMode();
				}
			}
			
			//Defect 249159: freeform page takes long time to initialize
			/*TIP_DOJO_NS*/dojo.require("dojo.data.ItemFileReadStore");
			dojo.require("com.ibm.isclite.dijit.dashboard.palette");
			var uid = pageDiv.modelObject.pageData.uid; 
			//hidding TR for freeform page in edit mode
			dojo.query('tr[class="toolbar-hide"]', pageDiv)[0].style.display = 'none';				
			//Initializing palette for a Freeform page in Edit mode
			
			var palette = new com.ibm.isclite.dijit.dashboard.palette({
				dataSourceURL: contextRoot + '/customizer.do?action=getPaletteContent&XSS='+top.window.XSS,
				pageSettingsButtonAction: dojo.query('input[name="page.titlebar.setting"]',pageDiv).map(function(n) {
					return {label: n.value, func: dojo.hitch(n, n.onclick)};
				})[0],
				showWiresButtonAction: dojo.query('input[name="page.titlebar.wires"]',pageDiv).map(function(n) {
					return {label: n.value, func: dojo.hitch(n, n.onclick)};
				})[0],
				saveButtonAction: dojo.query('input[name="page.titlebar.save"]',pageDiv).map(function(n) {
					return {label: n.value, func: dojo.hitch(n, n.onclick)};
				})[0],
				cancelButtonAction: dojo.query('input[name="page.titlebar.cancel"]',pageDiv).map(function(n) {
					return {label: n.value, func: dojo.hitch(n, n.onclick)};
				})[0]
			},dojo.byId(uid + 'palette'));
			dojo.style(uid + 'dashboard_palette_content', "display", "block");
			palette.startup();
			palette.filter.focus();
			pageDiv.modelObject.hookEditMode(palette);
		}

        var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
		var count = this.pagesInCustomMode[uniquePageName];
		if(!count){
			count = 0;
		}
		count++;
		this.pagesInCustomMode[uniquePageName] = count;
		//Defect 246008 - WireGUI: wire table is miss after switching
		var buttonId = uniquePageName + "_wires_button_id";
		var wireButton = /*TIP_DOJO_NS*/dojo.byId(buttonId);
		if (wireButton != null && wireButton.className.indexOf("isc-table-toolbar-buttonbar-hide") >= 0){
			var wireTable = /*TIP_DOJO_NS*/dojo.byId(uniquePageName+"_Wires_Table_ID");
			if (wireTable != null)
				wireTable.style.display = "";
		}
		//End Defect 246008 - WireGUI: wire table is miss after switching
		this.manageSaveButtonState(pageDiv);
		
		iWidgetUtils.updateSystemWires(pageDiv.modelObject.pageData.uid);
	},
    
	/*
	*	Enables/disables the Customizer save button, depending on PP presence on the page
	* 	pageDiv - the page div where the button resides, if it is not passed the method tries to retrieve it for the current page
	*/	
	manageSaveButtonState: function(pageDiv)
	{
		if(pageDiv == null)
		{
			pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		}
		
		var pickers = /*TIP_DOJO_NS*/dojo.query( 'div[name="thepicker"]', pageDiv );		
		if(pickers.length > 0)
		{
			this.disableSaveButton(true, pageDiv);
		}
		else
		{
			this.disableSaveButton(false, pageDiv);		
		}
	},	
	
	/*
	*	Disables the Customizer save button
	* 	pageDiv - the page div where the button resides, if it is not passed the method tries to retrieve it for the current page
	*	value - true - disables the button, false - enables the button
	*/
	disableSaveButton: function(value, pageDiv)
	{
		if(pageDiv == null)
		{
			pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		}	
		
		if (parent.taskbar./*TIP_DOJO_NS*/dojo != null) {
			var dropDownMenu = parent.taskbar./*TIP_DOJO_NS*/dojo.byId( 'PageAction' );
			var saveAsOption = parent.taskbar./*TIP_DOJO_NS*/dojo.query('option[value="SaveAs"]',dropDownMenu);
			if (saveAsOption.length > 0){
				if (value){
					saveAsOption[0].className = "isc-taskbar-pulldown-item-hide";
				}else{
					saveAsOption[0].className = "isc-taskbar-pulldown-item-show";
				}
			}
		}
		
		var saveBtn = /*TIP_DOJO_NS*/dojo.query( 'input[name="page.titlebar.save"]', pageDiv );
		if(saveBtn.length > 0)
		{
			saveBtn[0].disabled = value;
		}
	},	
	
    initEventsAndWiresClasses: function(){
        /*TIP_DOJO_NS*/dojo.require("ibm.tivoli.tip.TIPEventWiresAll");    	
        /*TIP_DOJO_NS*/dojo.require("com.ibm.isclite.dijit.custom.wires.WiresTable");   
        /*TIP_DOJO_NS*/dojo.require("dojo.data.ItemFileWriteStore");
        /*TIP_DOJO_NS*/dojo.require("dijit.dijit");
        /*TIP_DOJO_NS*/dojo.require("dojo.fx");
        /*TIP_DOJO_NS*/dojo.require("com.ibm.isclite.data.custom.eventsandwires.StoreManager");
        /*TIP_DOJO_NS*/dojo.require("com.ibm.isclite.dijit.custom.events.Events");
        /*TIP_DOJO_NS*/dojo.require("com.ibm.isclite.data.custom.eventsandwires.Controller");
        /*TIP_DOJO_NS*/dojo.require("com.ibm.isclite.data.custom.eventsandwires.WireDNDManager");
        
    },
    
	putPortletInCustomizeMode: function( portletDiv ) {

		var tbAccess = /*TIP_DOJO_NS*/dojo.query( ".isc-portlet-title-access", portletDiv )[0];
		var tempPortletDiv = portletDiv;
		if( /*TIP_DOJO_NS*/dojo.hasClass(portletDiv.parentNode, "isc-layout-window") ){
			tempPortletDiv = portletDiv.parentNode;
		}

		if( /*TIP_DOJO_NS*/dojo.hasClass(tempPortletDiv, "skinA") ){				 
			tbAccess.style.display = "";			 
		}
		else {
			tbAccess.style.display = "none";
		}
		iscPopupMenuHide();
		skins.initSkinAnimation(tempPortletDiv);

		var iscPortletDiv = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', portletDiv );
		if ((iscPortletDiv === undefined) || (iscPortletDiv.length < 1)) {
			var portletDivID = "iscPortlet_;" + portletDiv.id + ";edit_defaultsdialogDiv";
			portletDiv = /*TIP_DOJO_NS*/dojo.byId (portletDivID);
			iscPortletDiv = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', portletDiv );
		}	
		var portletData = iscPortletDiv[0].getAttribute( 'portletdataobject' );
		eval( 'var pageDataObject = ' + portletData );
		var basePii=pageDataObject.basePii;

        // event bubbling in FF causes mouseover for drop targets to not work
		// unless I just use the span instead of the table or TDs to listen
		// attach event handler for drag and drop
		if ( portletDiv.tagName.toLowerCase() != 'div' ) {
			//console.debug( 'yikes! expecting a DIV in customizer.putPortletInCustomizeMode() but got a ' + portletDiv.tagName );
			return;
		}
		var header = /*TIP_DOJO_NS*/dojo.query( 'table[name="portletHeaderTable"]', portletDiv )[0];
		if ( header === undefined ) return; // nothing here to work on...
		var span = /*TIP_DOJO_NS*/dojo.query( 'span', header )[0];
		/*TIP_DOJO_NS*/dojo.style( span, 'cursor', 'move' );
		if ( ! span.event ) {
			span.event = /*TIP_DOJO_NS*/dojo.connect( span, "onmousedown", customizer, "dndMouseDown" );
		}
		var ppDiv = /*TIP_DOJO_NS*/dojo.query("div[name='thepicker']",portletDiv);
		
		var isPP = false;
		if(ppDiv.length > 0)
		{
			isPP = true;
		}
		if ( ! isPP && ! portletDiv.sizeSent ) {
			// if this portlet's size isn't saved, save it - unless it's the portlet picker
			customizer.sendPortletSize( portletDiv );
		}

		var windowTd = portletDiv.parentNode;
		if ( windowTd.isEmptyTag ) {
			customizer.showEmptyWindow( windowTd );
		}
		
		// unhide any empty window titlebars...
        var titlebar = /*TIP_DOJO_NS*/dojo.query( 'td.isc-portlet-titlebar', portletDiv )[0];
        titlebar.style.visibility = '';
        		
		customizer.togglePortletTitleButtons( header ,basePii, isPP, portletDiv);
	},
	showEmptyWindows: function( pageDiv ) {
        // show empty windows (except titlebar) on sized pages
		// this is to make them occupy the space they are allotted but hide controls
        if ( pageDiv.modelObject.isNoSizePage() ) return;
        var windows = /*TIP_DOJO_NS*/dojo.query( 'td[name="emptyWindowToShow"]', pageDiv );
        for ( var i=0;i<windows.length;i++ ) {
			customizer.showEmptyWindow( windows[i] );
        }
    },
	showEmptyWindow: function( windowTd ) {
		var pageDiv = customizer.getContainingPageDiv( windowTd );
		if ( ! pageDiv.modelObject.isPageInEditMode() ) {
			var titlebar = /*TIP_DOJO_NS*/dojo.query( 'td.isc-portlet-titlebar', windowTd )[0];
			titlebar.style.visibility = 'hidden';
		}
		windowTd.style.display = '';
		windowTd.style.visibility = '';
		windowTd.style.opacity = '';
	},
	setupEventsAndWiresStoreManager: function(pageDiv){
		// creates the Event Wires and Target stores

        var moduleRef = pageDiv.modelObject.pageData.moduleRef;
        var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
		var id = uniquePageName+"_store_id";
		
		if(this.reloadStoreData)
		{
			this.destroyStoreManager(uniquePageName);
		}
		if(!/*TIP_DOJO_NS*/dijit.byId(id)){
		
			new com.ibm.isclite.data.custom.eventsandwires.StoreManager(moduleRef, uniquePageName,id);
		}
	},
    
    setupEventsAndWiresController: function(pageDiv){

        var moduleRef = pageDiv.modelObject.pageData.moduleRef;
        var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
        
        
		var id = uniquePageName+"_controller_id";
		if(this.reloadStoreData)
		{
			this.destroyController(uniquePageName);
		}
		
		if(!/*TIP_DOJO_NS*/dijit.byId(id)){
            var controller = new com.ibm.isclite.data.custom.eventsandwires.Controller(uniquePageName,id);
			//new com.ibm.isclite.data.custom.eventsandwires.StoreManager(moduleRef, uniquePageName,id);
            //controller.dispatcher("","newWire");
		}
	},
    
    controllerDispatch: function(uniquePageName,context,action){
        var id = uniquePageName+"_controller_id";
        var controller = /*TIP_DOJO_NS*/dijit.byId(id);
        if(controller){
            controller.dispatcher(context,action);
        }
    },
	
	destroyStoreManager: function(uniquePageName){
		var id = uniquePageName+"_store_id";
		var storeManager = /*TIP_DOJO_NS*/dijit.byId(id);
		if ( storeManager) storeManager.destroy();
	},
    
    destroyController: function(uniquePageName){
		var id = uniquePageName+"_controller_id";
		var controller = /*TIP_DOJO_NS*/dijit.byId(id);
		if (controller != undefined){
			controller.destroy();
		}
	},
	
	destroyEventTables: function(pageDiv){
	
		if (pageDiv.modelObject.pageData.layoutType == "Freeform"){   //Freeform case, different way of searching for portlets
			var widgets = Portlet.getPortletElements(pageDiv);
			for ( var x=0; x<widgets.length; x++ ) {
				var w = dijit.byId(widgets[x].id);
				if(w) {
					var pii = w.domNode.modelObject.portletData.basePii;
					var id = pii+"_portlet_events_dijit";
			
					var events = /*TIP_DOJO_NS*/dijit.byId(id);
					if(events){
						var eventsTableParentNode = events.domNode.parentNode;
						var oldPortletContentTable = /*TIP_DOJO_NS*/dojo.query( 'table:first-child', eventsTableParentNode )[0];
						oldPortletContentTable.style.display="";
						events.destroy();
					}
					
				}
			}
			

		}else {  //Classic Page case
			var portletDivArray = this.getAllPortletsOnPage(pageDiv);		
			for(var i in portletDivArray){
				var portletDiv = portletDivArray[i];
				var iscPortlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', portletDiv );
				if(iscPortlets.length!=1){
					continue;
				}
				var iscPortlet = iscPortlets[0];
				var portletData = iscPortlet.getAttribute("portletdataobject");
				eval( 'var portletDataObject = ' + portletData);
				var pii = portletDataObject.basePii;
				var id = pii+"_portlet_events_dijit";
				
				var events = /*TIP_DOJO_NS*/dijit.byId(id);
				if(events){
					var eventsTableParentNode = events.domNode.parentNode;
					var oldPortletContentTable = /*TIP_DOJO_NS*/dojo.query( 'table:first-child', eventsTableParentNode )[0];
					oldPortletContentTable.style.display="";
					events.destroy();
				}
			}
		
		}
		
	
	},
	
	leaveCustomizeMode: function( pageDiv ) {
		// removes the visual aspects of Customize mode
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;

        var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;

		var count = this.pagesInCustomMode[uniquePageName];
		count--;
		this.pagesInCustomMode[uniquePageName] = count;
		//destroy wire table
		if(count==0){
			this.destroyWireTable(uniquePageName);
			this.destroyStoreManager(uniquePageName);
            this.destroyController(uniquePageName);
			this.destroyEventTables(pageDiv);			
		}
		
		pageDiv.modelObject.setPageShowingEditMode( false );
		pageDiv.modelObject.setPageInEditMode( false );
		var layoutRoot = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if ( typeof layoutRoot == 'undefined' || !layoutRoot ) {
			//console.log( "error: layout root not found" )
			return;
		}
		// find and hide sizer bars (this works for page sizers as well)
		/*TIP_DOJO_NS*/dojo.query( 'td[class^="isc-layout-sizebar-"]', layoutRoot ).forEach(
			function( i ) {
				/*TIP_DOJO_NS*/dojo.style( i, 'visibility', 'hidden' );
			}
		);
		// toggle display of save/cancel buttons for this page
        /*TIP_DOJO_NS*/dojo.query( 'td.isc-table-toolbar-buttonbar', pageDiv ).forEach(
			function( i ) {
				/*TIP_DOJO_NS*/dojo.removeClass( i, 'isc-table-toolbar-buttonbar' );
				/*TIP_DOJO_NS*/dojo.addClass( i, 'isc-table-toolbar-buttonbar-hide' );
			}
		);
		// toggle dropdown menu items. see note in enterCustomizeMode about IE bug
		var dropDownMenu = parent.taskbar./*TIP_DOJO_NS*/dojo.byId( 'PageAction' );
		if (dropDownMenu){
			dropDownMenu.selectedIndex = 0;
			for ( var i=0; i<dropDownMenu.options.length; i++ ) {
				if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-hide' ) {
					dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-show';
				} else if ( dropDownMenu.options[i].className == 'isc-taskbar-pulldown-item-show' ) {
					dropDownMenu.options[i].className = 'isc-taskbar-pulldown-item-hide';
				}
			}
		}
		var portlets = UIElement.getElementsByName( pageDiv, "PortletFragment" );
		for ( var i=0; i<portlets.length; i++ ) {
			customizer.takePortletOutCustomizeMode( portlets[i] );
		}
	},
	
	destroyEventsAndWiresObjectsOnCancel: function( pageDiv ) {
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;

		var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
		this.destroyWireTable(uniquePageName);
		this.destroyStoreManager(uniquePageName);
		this.destroyController(uniquePageName);
		this.reloadStoreData=false;

	},
	destroyEventsAndWiresObjectsOnSave: function( pageDiv ) {
		if ( typeof pageDiv == 'undefined' || !pageDiv ) return;

		var referencePageName = pageDiv.modelObject.pageData.referencePageName;

		this.destroyPiis(referencePageName,this.piiContainerArray);
		this.destroyWireTable(referencePageName);
		this.destroyStoreManager(referencePageName);
		this.destroyController(referencePageName);
		this.reloadStoreData=true;

	},
	
	destroyPiis : function(uniquePageName,piiArray) {
		for (var i=0; i<piiArray.length; i++) {
			
			var pii = piiArray[i];
			var id = pii+"_portlet_events_dijit";
			var eventsTable  = /*TIP_DOJO_NS*/dijit.byId(id);
			
			var storeManagerId = uniquePageName+"_store_id";
			var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId);
			var eventStore = storeManager.getEventsStore();

			if(eventsTable){
               
				eventsTable.destroy();
				/*TIP_DOJO_NS*/dijit.registry.remove(id);
				var publishId = id + "_publish";
				var publish = /*TIP_DOJO_NS*/dijit.byId(publishId);
				if (publish) {
					publish.destroy();
				}

				var subscribeId = id + "_subscribe";
				var subscribe = /*TIP_DOJO_NS*/dijit.byId(subscribeId);
				if (subscribe) {
					subscribe.destroy();
				}

				var publishEventTableId = id + "_publish_eventTable";
				var publishEventTable = /*TIP_DOJO_NS*/dijit.byId(publishEventTableId);
				if (publishEventTable) {
					publishEventTable.destroy();
				}

				var subscribeEventTableId = id + "_subscribe_eventTable";
				var subscribeEventTable = /*TIP_DOJO_NS*/dijit.byId(subscribeEventTableId);
				if (subscribeEventTable) {
					subscribeEventTable.destroy();
				}

				function onItem(item){
          
					var eventId =eventStore.getValue(item,"id");
					
					var publishEventEnableCheckBoxId = id + "_publish_eventTable_"+eventId+"_enableCheckBox";
					var publishEventEnableCheckBox = /*TIP_DOJO_NS*/dijit.byId(publishEventEnableCheckBoxId);
					if(publishEventEnableCheckBox) {
						publishEventEnableCheckBox.destroy();
					}

					var publishEventParamTreeId = id + "_publish_eventTable_"+eventId+"_paramTree";
					var publishEventParamTree = /*TIP_DOJO_NS*/dijit.byId(publishEventParamTreeId);
					if(publishEventParamTree) {
						publishEventParamTree.destroy();
					}

					var subscribeEventEnableCheckBoxId = id + "_subscribe_eventTable_"+eventId+"_enableCheckBox";
					var subscribeEventEnableCheckBox = /*TIP_DOJO_NS*/dijit.byId(subscribeEventEnableCheckBoxId);
					if(subscribeEventEnableCheckBox) {
						subscribeEventEnableCheckBox.destroy();
					}

					var subscribeEventParamTreeId = id + "_subscribe_eventTable_"+eventId+"_paramTree";
					var subscribeEventParamTree = /*TIP_DOJO_NS*/dijit.byId(subscribeEventParamTreeId);
					if(subscribeEventParamTree) {
						subscribeEventParamTree.destroy();
					}
					
				};
				eventStore.fetch({pii: pii, onItem: onItem});
				eventsTable = null;
			}
		}
	},
	
	takePortletOutCustomizeMode: function( portletDiv) {
		var iscPortletDiv = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', portletDiv );
		var portletData = iscPortletDiv[0].getAttribute( 'portletdataobject' );
		eval( 'var pageDataObject = ' + portletData );
		var basePii=pageDataObject.basePii;


		if ( portletDiv.tagName.toLowerCase() != 'div' ) {
			//console.log( 'yikes! expecting a DIV in customizer.putPortletInCustomizeMode() but got a ' + portletDiv.tagName );
			return;
		}
		var header = /*TIP_DOJO_NS*/dojo.query( 'table[name="portletHeaderTable"]', portletDiv )[0];
		if ( header === undefined ) return; // nothing here to work on...
		var span = /*TIP_DOJO_NS*/dojo.query( 'span', header )[0];
		/*TIP_DOJO_NS*/dojo.style( span, 'cursor', '' );
		/*TIP_DOJO_NS*/dojo.disconnect( span.event );
		customizer.togglePortletTitleButtons( header,basePii, true, portletDiv);
	},
	togglePortletTitleButtons: function( portletTitleBar,basePii,isPP, portletDiv ) {

		this.initEventsAndWiresClasses();
		// toggle display of portlet title bar controls
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );

        var inEditMode = currentPageDiv.modelObject.isPageInEditMode();
		for ( var i=0; i<portletTitleBar.rows[0].cells.length; i++ ) { //DO NOT skip first cell anymore
			//Reason for the change: 208968 - GVT: 'Create new page' cann't be displayed in Hebrew
			//skipping the first cell is working in case we have LTR language, but in RTL case we should skip the last cell(thats the portlet title actually)
			//as it seems here we do not have information about the language orientation, I am checking for the appropriate class - 'isc-portlet-titlebar-button'
			//as we only take care of the buttons here, this change should be working fine
			var td = portletTitleBar.rows[0].cells[i];
			
			if(td.className != 'isc-portlet-titlebar-button' && td.className != 'isc-layout-portlet-titlebar-customizer-icon-hide')
			{
				continue;
			}
			var link = td.getElementsByTagName( 'A' )[0];
			if (link === undefined) {
				continue;
			}
			var show = 'isc-portlet-titlebar-button';
			var hide = 'isc-layout-portlet-titlebar-customizer-icon-hide';
			var linkName = link.getAttribute( 'name' );
			if ( linkName === null ) { linkName = ''; }
			if ( linkName == 'IscPortletEvents' ) {
				//td.className = ( inEditMode ) ? show : hide;
                td.className = hide;
                if(inEditMode){

		    var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;


            var storeManagerId = uniquePageName+"_store_id";
		
                    var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId);
		    
                    if(storeManager){
                       //var iw= iWBridge.findiWidgetID(portletDiv); - no need for this anymore  Defect 248168
                       var iscPortletDiv = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', portletDiv );
                       var portletData = iscPortletDiv[0].getAttribute( 'portletdataobject' );
                       eval( 'var pageDataObject = ' + portletData );
                       var pii=pageDataObject.oid;
                       var iw = iWidgetUtils.piiToWidgetId(pii);

                       if (iw===null) {
                          storeManager.showEventIconsWithPublishEvents(td,basePii, isPP);
                       } else{
                          td.className = 'isc-portlet-titlebar-button';
                        //defect 245866 - Showwires button unavailable after save the page.
                          // wireButton with the same id may be exist in many pages since state maintained.
                          // this.currentPageId does not contain the tid, so can not tell the difference between two page with the same content.
                          var wireButton = null;
                      	
	                      	/*TIP_DOJO_NS*/dojo.query("input[name='page.titlebar.wires']",currentPageDiv).forEach(function(node){
	                      		wireButton = node;
	                      	});
	                    //End defect 245866 - Showwires button unavailable after save the page.
                          wireButton.disabled = false;
                         }
                    }
                }
				// attach event handler for events button
// why don't we just generate the onclick handling markup in Content.jsp? 
// I do for the events menu item, and it seems to work fine.
//				if ( ! link.onclickevent ) {
//					link.onclickevent = /*TIP_DOJO_NS*/dojo.connect( link, "onclick", customizer, "hideShowEvents" );
//				}
			}else if ( linkName.match( /^IscCustomizer.*Split$/ ) !== null ) {
				td.className = ( inEditMode ) ? show : hide;
				// attach event handler for splitter buttons
				if ( ! link.onclickevent ) {
					link.onclickevent = /*TIP_DOJO_NS*/dojo.connect( link, "onclick", customizer, "splitter" );
				}
				
				// 254539. a11y: To active split button by pressing SpaceBar.
				if( !link.onkeydownevent ) {
					link.onkeydownevent = dojo.connect(link, 'onkeydown', customizer, 'splitButtonOnSpaceKey');
				}
			} else if ( linkName == 'IscCustomizerDelete' ) {
				td.className = ( inEditMode ) ? show : hide;
				// attach event handler for delete button
				if ( ! link.onclickevent ) {
					link.onclickevent = /*TIP_DOJO_NS*/dojo.connect( link, "onclick", customizer, "deleter" );
				}
			} else if ( linkName == 'IscCustomizerReplace' ) {
				
				td.className = ( inEditMode ) ? show : hide;
				// attach event handler for delete button
				if ( ! link.onclickevent ) {
					link.onclickevent = /*TIP_DOJO_NS*/dojo.connect( link, "onclick", customizer, "replacePortlet" );
				}
			} else if ( linkName == 'IscSkinMenu' ) {				
				td.className = ( inEditMode ) ? show : hide;				
			} else if ( linkName == 'IscHelp'){
                td.className=show;
			} else if ( linkName == 'IscEditDefault') {
                td.className=show;
			} else if ( linkName == 'IscBack') {
                td.className=show;
            } else if ( linkName == 'IscEditAndEditDefault') {
                td.className=show;
                // find the personalize anchor and hide it
                var div = td.getElementsByTagName ("div")[0];
                //var div2 = div.getElementsByTagName ("div")[0];
                //var div3 = div2.getElementsByTagName ("div")[0];				
				///*TIP_DOJO_NS*/dojo.style (div3, "display", "none");

            } else {
				td.className = ( inEditMode ) ? hide : show;
			}
		}
		customizer.setupDropDownMenu(portletDiv);
	},
	setupDropDownMenu: function(portletDiv) {		
		var menuDiv = dojo.byId("iscEditPopupMenu_" + portletDiv.id);
		if(!menuDiv)
			return;

		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
        var inEditMode = currentPageDiv.modelObject.isPageInEditMode();
		if(inEditMode) {
			customizer.updateDOMStyle("menuSeperatorOption", "menuSeperatorClass", menuDiv, "");
		}
		// the personalize menu item
		customizer.updateDOMStyle("editOption", "personalizeClass", menuDiv, inEditMode ? "" : "none");
				
		// the skin menu item
		customizer.updateDOMStyle("skinMenuOption", "skinMenuClass", menuDiv, inEditMode ? "" : "none");

		// find the replace portlet menu div, hide/un-hide depending upon isEditMode value
		customizer.updateDOMStyle("IscCustomizerReplaceOption", "replaceOptionClass", menuDiv, inEditMode ? "" : "none");

		// find the delete portlet menu div, hide/un-hide depending upon isEditMode value
		customizer.updateDOMStyle("IscCustomizerDeleteOption", "deleteOptionClass", menuDiv, inEditMode ? "" : "none");

		// find the about portlet menu div, hide/un-hide depending upon isEditMode value
		customizer.updateDOMStyle("IscCustomizerAboutOption", "aboutOptionClass", menuDiv, inEditMode ? "" : "none");

		// find the minimize portlet menu
		customizer.updateDOMStyle("minimizeOption", "minimizeOptionClass", menuDiv, inEditMode ? "none" : "");
		
		// find the restore portlet menu div
		customizer.updateDOMStyle("restoreOption", "restoreOptionClass", menuDiv, inEditMode ? "none" : "");
		
		// find the maximize portlet menu div
		customizer.updateDOMStyle("maximizeOption", "maximizeOptionClass", menuDiv, inEditMode ? "none" : "");

		// find the events menu div, hide it
		var eventFlag = false;
		var eventsOptionDiv = dojo.query("div[name='IscCustomizerEventsOption']",portletDiv);					
		if(eventsOptionDiv.length > 0){
			eventFlag = true;
			dojo.style (eventsOptionDiv[0], "display", "none");							
		}else{
			dojo.query( "tr.eventsOptionClass", portletDiv ).forEach(
			function( i ) {				
				eventFlag = true;
				dojo.style (i, "display", "none");
			}
			);			
		}
		
		if((eventFlag == true) && (inEditMode == true)){
		    var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
            var storeManagerId = uniquePageName+"_store_id";		
            var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId);
		    
               if(storeManager){
                       var iw= iWBridge.findiWidgetID(portletDiv);
                       if (iw===null) {
						   //TODO : need to update this flow for menu
                         // storeManager.showEventIconsWithPublishEvents(td,basePii, isPP);
                       } else{
                          //td.className = 'isc-portlet-titlebar-button';
						  customizer.updateDOMStyle("IscCustomizerEventsOption", "eventsOptionClass", portletDiv, "");
                        //defect 245866 - Showwires button unavailable after save the page.
                          // wireButton with the same id may be exist in many pages since state maintained.
                          // this.currentPageId does not contain the tid, so can not tell the difference between two page with the same content.
                          var wireButton = null;
                      	
	                      	/*TIP_DOJO_NS*/dojo.query("input[name='page.titlebar.wires']",currentPageDiv).forEach(function(node){
	                      		wireButton = node;
	                      	});
	                    //End defect 245866 - Showwires button unavailable after save the page.
                          wireButton.disabled = false;
                         }
                 }
         }
	},
	// once upon a time, the menu was implemented in hand crafted html.
	// now that it's a dijit.Menu, divName is unused, trName is the class name assigned to the men
	updateDOMStyle: function(divName, trName, menuDiv, dispValue) {		
		//used to update a DOM with a given style
		dojo.query("[class*='" + trName + "']", menuDiv).forEach(function(n) {
			dojo.style(n, "display", dispValue);
		});
		return;
		
		
        var menuElementDiv = dojo.query("div[name='"+divName+"']",menuDiv);			
        if(menuElementDiv.length > 0){
        for(var i=0;i<menuElementDiv.length;i++){				
            dojo.style (menuElementDiv[i], "display", dispValue);					
        }				
        }else{
            var trElementDiv = dojo.query( "tr."+trName, menuDiv )
            if (trElementDiv.length > 0) {
                for (var i = 0; i < trElementDiv.length; i++) {
                    dojo.style(trElementDiv[i], "display", dispValue);
                }
            } else {
                var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
                var menuElementDiv = dojo.query("div[name='"+divName+"']",currentPageDiv);            
                if(menuElementDiv.length > 0){
		            for(var i=0;i<menuElementDiv.length;i++){               
		                dojo.style (menuElementDiv[i], "display", dispValue);                    
		            }               
		        }else{
		            dojo.query( "tr."+trName, currentPageDiv ).forEach(
		            function( i ) {
                        dojo.style (i, "display", dispValue);
                    }
                    );          
                }
            }
        }
	},
	emptyMenuDiv: function( oid ) {
		// TODO: I don't think this function is called from anywhere any more
		// If it is, you need to know that iscEditPopupMenuInnerDiv no longer exists
		if (/*TIP_DOJO_NS*/dijit.byId("iscEditPopupMenu_"+oid)) {
			//clean up the widgets
			var widgetArr = /*TIP_DOJO_NS*/dijit.byId("iscEditPopupMenu_"+oid).getChildren();
			/*TIP_DOJO_NS*/dojo.forEach(widgetArr, function(child){
			child.destroyRecursive();
			});
			/*TIP_DOJO_NS*/dijit.byId("iscEditPopupMenu_"+oid).destroyRecursive();
		} 	
  		
		if (/*TIP_DOJO_NS*/dijit.byId("iscEditPopupMenuInnerDiv_"+oid)) {
			//clean up the widgets
			var widgetArr = /*TIP_DOJO_NS*/dijit.byId("iscEditPopupMenuInnerDiv_"+oid).getChildren();
			/*TIP_DOJO_NS*/dojo.forEach(widgetArr, function(child){
			child.destroyRecursive();
			});
			/*TIP_DOJO_NS*/dijit.byId("iscEditPopupMenuInnerDiv_"+oid).destroyRecursive();
		} 		
		
		if (/*TIP_DOJO_NS*/dijit.byId("iscEditPopupSubMenu1_"+oid)) {
			//clean up the widgets
			var widgetArr = /*TIP_DOJO_NS*/dijit.byId("iscEditPopupSubMenu1_"+oid).getChildren();
			/*TIP_DOJO_NS*/dojo.forEach(widgetArr, function(child){
			child.destroyRecursive();
			});
			/*TIP_DOJO_NS*/dijit.byId("iscEditPopupSubMenu1_"+oid).destroyRecursive();
		}
	},
	checkIfPageDiv: function( node ) {
		// used as a filter function to id page divs
		return ( node.nodeName == 'DIV' && node.getAttribute( 'name' ) == 'IscPage' );
	},
	checkIfPortlet: function( node ) {
		// used as a filter function to id portlet divs
		return ( node.nodeName == 'DIV' && node.getAttribute( 'name' ) == 'PortletFragment' );
	},
	getAllPortletsOnPage: function( pageDiv ) {
		var portlets = new Array();
		var divs = pageDiv.getElementsByTagName( 'DIV' );
		for ( var i=0; i<divs.length; i++ ) {
			if ( divs[i].getAttribute( 'name' ) == 'PortletFragment' ) {
				portlets.push( divs[i] );
			}
		}
		return portlets;
	},
	getContainingPageDiv: function( node ) {
		return customizer.getAncestors( node, customizer.checkIfPageDiv, true );
	},
	getContainingPortlet: function( node ) {
		// used from portlet headers to get containing portlet DIV
		return customizer.getAncestors( node, customizer.checkIfPortlet, true );
	},
	getPortletHeaderHeight: function( portletDiv ) {
		// find the rendered height of the portlet header bar
		var tr = /*TIP_DOJO_NS*/dojo.query( 'td.isc-portlet-titlebar', portletDiv )[0].parentNode;
		return /*TIP_DOJO_NS*/dojo.marginBox( tr ).h;
	},
	checkIfContainerTable: function( node ) {
		// used as a filter function to id container tables
		return ( node.nodeName == 'TABLE' && ( node.className.match( /^isc-layout-(stretchy-)?(container|root-table)$/ ) != null ) );
	},
	checkIfRootTable: function( node ) {
		return ( node.nodeName == 'TABLE' && ( node.className.match( /^isc-layout-(stretchy-)?root-table$/ ) != null ) );
	},
	getOrientation: function( node ) {
		// return which orientation of container this node is in
		// node is some element in the portlet or portlet decoration
		// or a sizer component or a container table
		// note that this *might* not match PAA but this is what makes sense here
		// this assumes a distilled layout!!
		// TODO: make sure this handles an unsplit root correctly...	
		if ( ! customizer.checkIfContainerTable( node ) ) {
			node = customizer.getAncestors( node, customizer.checkIfContainerTable, true );
		}
		if ( ( ( node.className.match( /-root-table$/ ) != null ) && ( node.rows.length < 3 ) ) ||
				( ( node.className.match( /-container$/ ) != null ) && ( node.rows.length == 1 ) ) ) {
			return 'row';
		} else {
			return 'col';
		}
	},
	isOrthogonal: function( node ) {
		// return bool reflecting if this node's orientation is orthogonal
		// to the current sizing direction
		var thisOrientation = customizer.getOrientation( node );
		return ( thisOrientation != customizer.sizerOrientation );
	},
	sendPortletSize: function( div ) {
		var METHODNAME = "sendPortletSize ";
		//console.log( METHODNAME + "Entry, div.id: " + div.id );
		var width = 0;
		var height = 0;
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );

		if (currentPageDiv.modelObject.pageData.layoutType != "Freeform"){
			customizer.calcRelativePortletPercent( div );
		}

		width = parseInt( div.style.width ); // TODO - compare to API
		height = parseInt( div.style.height );
		//console.log( METHODNAME + "after calc width,height : " + width + "," + height );

		/* console.log( METHODNAME + "Calling sizePortletDiv" ); */ customizer.sizePortletDiv( div, width, height );

		if ( ! currentPageDiv.modelObject.isPageInEditMode() ) {
			// add percent to the width/height
			//  to be used when restoring a nonSM page with temp data in the DOM
			var pii = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', div )[0].modelObject.portletData.basePii;
			var pageId = currentPageDiv.modelObject.getPageUID();
			// saving to temp store in personal resize mode
			// so that sizes can be restored if a nonSM page loses focus and regains it before saving
			if ( ! customizer.tempResizeStore[pageId] ) {
				// create temp size store and enable save/cancel buttons
				customizer.tempResizeStore[pageId] = {};
				customizer.initResizeSaveCancel( currentPageDiv );
			}
			customizer.tempResizeStore[pageId][pii] = [ width, height, div.percent.w, div.percent.h ];
		} else {
			div.sizeSent = true;
			// normal customizer mode saving
			var uid = currentPageDiv.modelObject.pageData.tid;
			var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
			if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
				uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
			var url = contextRoot + '/customizer.do?action=resize'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + uniquePageName
			                + '&XSS=' + top.window.XSS
					+ '&windowId=' + div.id
					+ '&width1=' + width
					+ '&height1=' + height;
			if ( uid ) url += '&uid=' + uid;
			url = encodeURI( url );
			/*TIP_DOJO_NS*/dojo.xhrGet( {
				url: url,
				load: function( type, data, evt ) { },
				handleAs: "text"
			} );
		}
		//console.log( METHODNAME, "Exit" );
	},
	isClientWindowMode: function (oid) {
		var portletObj = EventBroker.getPortletObjectByPii(oid, IscPages.currentPageId, true);
		var eventSettingsJSON = portletObj.element.getAttribute("eventSettings");
		var eventSettingsObj = /*TIP_DOJO_NS*/dojo.fromJson (eventSettingsJSON);
		var supportedProcessingEvents = eventSettingsObj.processingEvents;
		for (var i=0; i<supportedProcessingEvents.length; i++) {
			if (supportedProcessingEvents[i] == "http://ibm.com/isclite#cws") {
				return (true);
			}
		}
		
		return (false);	
	},
	oidToNamespace: function (oid) {
		var portletObj = EventBroker.getPortletObjectByPii(oid, IscPages.currentPageId, true);
		var namespace = portletObj.portletData.namespace;

		return (namespace);
	},
	maximizeClicked: function (oid, page) {
		if (this.isClientWindowMode(oid)) {
			iWidgetToolbar.maximizeWindow (oid);
		} else {
			this.openPage (page);
		}
	},
	minimizeClicked: function (oid, page) {
		if (this.isClientWindowMode(oid)) {
			iWidgetToolbar.minimizeWindow (oid);
		} else {
			this.openPage (page);
		}
	},
	restoreClicked: function (oid, page) {
		if (this.isClientWindowMode(oid)) {
			iWidgetToolbar.normalizeWindow (oid);

		} else {
			this.openPage (page);
		}
	},
	openPage: function(page) {
		iscPopupMenuQuickHide();
		SMUtils.RequestFragmentCollection (page, null, null);
	},
    updateSkin: function(windowId, skin, menuItem) {
		iscPopupMenuQuickHide();
		//update the window with a skin class and make an ajax call to save the skin
		var div = /*TIP_DOJO_NS*/dojo.byId("isc-layout-window"+windowId);		
		if(div == null) {
			//freeform page does not have td with isc-layout-window, so handle the div with id as window id
			div = document.getElementById(windowId);
		}		
		customizer.clearSkins(div);
		/*TIP_DOJO_NS*/dojo.addClass(div, skin);
		iscPortlet.sendResizeEvent('customizer.updateSkin');
                	var tbAccess = /*TIP_DOJO_NS*/dojo.query( ".isc-portlet-title-access", div )[0];
		if(skin == "skinA") {			
			tbAccess.style.display = "";
		}
		else {
			tbAccess.style.display = "none";
		}
		skins.initSkinAnimation(div);
		customizer.updateWindowSkin(windowId, skin);
		customizer.checkMenuItem("undefined" === typeof menuItem.declaredClass ? /*TIP_DOJO_NS*/dijit.getEnclosingWidget(menuItem) : menuItem);
	},
	checkMenuItem: function(menuItem) {
		// update the skin menu with a check mark for the clicked menu item
		var menuParent = /*TIP_DOJO_NS*/dijit.getEnclosingWidget(menuItem.domNode.parentNode);
		var menuArr = menuParent.getChildren();
		/*TIP_DOJO_NS*/dojo.forEach(menuArr, function(child){
			/*TIP_DOJO_NS*/dojo.attr(child, "iconClass", "");
		});
		/*TIP_DOJO_NS*/dojo.attr(menuItem, "iconClass", "iscPrPopUpSkinCheckedMenuItemIcon");
	},		
	clearSkins: function(div) {
		//remove all existing skins from the div
		/*TIP_DOJO_NS*/dojo.removeClass( div, "skinA");
		/*TIP_DOJO_NS*/dojo.removeClass( div, "skinB");
		/*TIP_DOJO_NS*/dojo.removeClass( div, "skinC");
	},
	updateWindowSkin: function( windowId, skin ) {
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );		
		
		// normal customizer mode saving
		var uid = currentPageDiv.modelObject.pageData.tid;
		var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
		if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
			uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
		var url = contextRoot + '/customizer.do?action=updateskin'
				+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
				+ '&pageId=' + uniquePageName
		                + '&XSS=' + top.window.XSS
				+ '&windowId=' + windowId
				+ '&skin=' + skin;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text"
		} );		
	},
	getAdjacentPortlets: function( sizerTd, side ) {
		// return an array of portlet divs that share an edge with the sizer TD
		// side is either "previous" or "next"
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		if ( customizer.smallestX != null && customizer.smallestY != null ) {
			customizer.smallestX[side] = 100000;
			customizer.smallestY[side] = 100000;
		}
		var portletDivs = new Array();
		function checkTdForWindow( windowTd ) {
			if( /*TIP_DOJO_NS*/dojo.hasClass( windowTd, 'isc-layout-window' ) ) {
				// this TD is a window containing a portlet.  add that portlet DIV to the array
				var div = /*TIP_DOJO_NS*/dojo.query( 'div[name="PortletFragment"]', windowTd )[0];
				div.sizeSent = false;
				var origwidth = parseInt( /*TIP_DOJO_NS*/dojo.style( div, 'width' ) );
				var origheight = parseInt( /*TIP_DOJO_NS*/dojo.style( div, 'height' ) );
				if ( customizer.smallestX != null && customizer.smallestY != null ) {
					if ( origwidth < customizer.smallestX[side] ) customizer.smallestX[side] = origwidth;
					if ( origheight < customizer.smallestY[side] ) customizer.smallestY[side] = origheight;
				}
				// store original size
				div.setAttribute( 'origwidth', origwidth );
				div.setAttribute( 'origheight', origheight );
				portletDivs.push( div );
				return;
			} else if ( windowTd.className.match( /^isc-layout-sizebar-/ ) != null ) {
				// this is a sizer - ignore it
				return;
			} else if ( windowTd.className == '' ) {
				// this TD should contain a table - need to recurse
				var table = /*TIP_DOJO_NS*/dojo.query( 'table:first-child', windowTd )[0];
				if ( table.className.match( /^isc-layout-(stretchy-)?(container|root-table)$/ ) != null ) {
					findTdsInTable( table );
				} else {
					// ERROR: we have a stray table
					return;
				}
			}
		}
		function findTdsInTable( table ) {
			if ( customizer.isOrthogonal( table ) ) {
				// check all cells in both row and col orientation
				for ( var r=0; r<table.rows.length; r++ ) {
					for ( var c=0; c<table.rows[r].cells.length; c++ ) {
						checkTdForWindow( table.rows[r].cells[c] );
					}
				}
			} else {
				// need to only check endcells for orthogonal orientations
				if ( side == 'previous' ) {
					// for previous side we check last cell contents
					checkTdForWindow( table.rows[table.rows.length - 1].cells[table.rows[table.rows.length - 1].cells.length - 1] );
				} else {
					// for next side we check first cell contents
					checkTdForWindow( table.rows[0].cells[0] );
				}
			}
		}
		var sizerTdName = sizerTd.getAttribute( 'name' );
		if ( ( sizerTdName != null ) && ( sizerTdName.match( /^layoutsizer/ ) != null ) ) {
			// start the recursion...
			findTdsInTable( customizer.getFirstAncestorByTag( sizerTd, 'TABLE' ) );
		} else {
			var windowTd = null;
			// find the starting TDs on either side of the sizer
			if ( side == 'previous' ) {
				if ( customizer.sizerOrientation == 'row' ) {
					windowTd = customizer.getPreviousSiblingElement( sizerTd, 'TD' );
				} else {
					windowTd = /*TIP_DOJO_NS*/dojo.query( 'td', customizer.getPreviousSiblingElement( sizerTd.parentNode, 'TR' ) )[0];
				}
			} else if ( side == 'next' ) {
				if ( customizer.sizerOrientation == 'row' ) {
					windowTd = customizer.getNextSiblingElement( sizerTd, 'TD' );
				} else {
					windowTd = /*TIP_DOJO_NS*/dojo.query( 'td', customizer.getNextSiblingElement( sizerTd.parentNode, 'TR' ) )[0];
				}
			} else {
				return null;
			}
			// start the recursion...
			checkTdForWindow( windowTd );
		}
		return portletDivs;
	},
	createSizer: function( orientation ) {
		// create a sizer to be used when adding new windows during splitting
		// orientation is "col" or "row"
		var newSizerCell = document.createElement( 'TD' );
		var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		newSizerCell.style.visibility = 'visible';
		newSizerCell.event = /*TIP_DOJO_NS*/dojo.connect( newSizerCell, "onmousedown", customizer, "sizeMouseDown" );
		var newSizerImage = document.createElement( 'IMG' );
		newSizerCell.appendChild( newSizerImage );
		newSizerImage.title = customizer.nlsResources['customizer.resize.sizerbar.customizemode'];
		if ( orientation == 'col' ) {
			// need a TR, TD, image
			var newSizerRow = document.createElement( 'TR' );
			newSizerCell.className = 'isc-layout-sizebar-horizontal';
			newSizerImage.src = contextRoot + '/ISCProxy/images/content/isc_grabbies_horz.gif';
			newSizerRow.appendChild( newSizerCell );
			return newSizerRow;
		} else {
			// only need a TD with image
			newSizerCell.className = 'isc-layout-sizebar-vertical';
			newSizerImage.src = contextRoot + '/ISCProxy/images/content/isc_grabbies_vert.gif';
			return newSizerCell;
		}
	},
	insertPortletSM: function( placeHolderTd, ajaxdata ) {
		// this uses SMUtils code to place content gotten from an AJAX update
		// into a placeholder for that portlet.  The placeholder must be a TD
		// with one DIV inside it.  The DIV should have sizes on it already in pixel mode.
		// also requires the TABLE inside the DIV
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = /*TIP_DOJO_NS*/dojo.query( 'div', placeHolderTd )[0];
		if ( typeof portletDiv == 'undefined' || !portletDiv ) {
			// console.log( "insertPortletSM: the placeHolderTd doesn't have the DIV it needs in it" );
			return; // broken placeholder
		}
		portletDiv.setAttribute( 'name', 'PortletFragment' );
		var portletTable = document.createElement( 'TABLE' );
		portletDiv.innerHTML = '';
		portletDiv.appendChild( portletTable );
		// get id and pageid from ajax data
		var tempDiv = document.createElement( 'DIV' );
		tempDiv.innerHTML = ajaxdata;
		var newPortletFragment = /*TIP_DOJO_NS*/dojo.query( 'div[name="PortletFragment"]', tempDiv )[0];
		portletDiv.id = newPortletFragment.id;
		portletDiv.style.overflow = 'auto';
		portletDiv.style.position = 'relative'; //249590f_1
		portletDiv.setAttribute( 'pageid', newPortletFragment.getAttribute( 'pageid' ) );
		portletTableInTempDiv = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', newPortletFragment )[0];
		for ( var i=0; i<portletTableInTempDiv.attributes.length; i++ ) {
			portletTable.setAttribute( portletTableInTempDiv.attributes[i].name, portletTableInTempDiv.attributes[i].value );
		}
		tempDiv = null;
		portletDiv.modelObject = new Portlet( currentPageDiv.modelObject, portletTable );
		// call SM code to update the content
		IscPages.UpdatePortletFragments( ajaxdata );
		customizer.sendPortletSize( portletDiv );
		customizer.putPortletInCustomizeMode( portletDiv );				
	},
	
	/**
	 *  254539. a11y: To active portlet spliting button by pressing SpaceBar.
	 */
	splitButtonOnSpaceKey: function(e) {
		if(e.keyCode != 13 && e.keyCode != 32) {
			return true;
		}
		customizer.splitter(e);
		
		e.preventDefault();
		return false;
	},
	
	/*--- start splitter code ---*/
	splitter: function( event ) {
		var currentTarget = event.currentTarget;
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = customizer.getContainingPortlet( currentTarget );
		// make sure that the first window size gets sent at the first split
		if ( ! portletDiv.sizeSent ) customizer.sendPortletSize( portletDiv );
		portletDiv.sizeSent = false;
		var urlOrientation = 'horizontal';
		if ( event.currentTarget.getAttribute( 'name' ) == 'IscCustomizerVertSplit' ) urlOrientation = 'vertical';
		// AJAX and get the picker portlet
		var uid = currentPageDiv.modelObject.pageData.tid;
		var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
		if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
			uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
		var url = contextRoot + '/customizer.do?action=split'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + uniquePageName
			                + '&XSS=' + top.window.XSS
					+ '&windowId=' + portletDiv.id
					+ '&orientation=' + urlOrientation;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			handleAs: "text",
			load: function( response, ioargs ) { customizer.splitterpart2( currentTarget, response ) }
		} );
	},
	splitterpart2: function( clickedTarget, data ) {
		var METHODNAME = "splitterpart2 ";
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = customizer.getContainingPortlet( clickedTarget );
		var currentRow = customizer.getFirstAncestorByTag( portletDiv, 'TR' );
		var orientation = customizer.getOrientation( portletDiv );
		var currentSpaceWidth = '';
		var newSpace1Width = '';
		var newSpace2Height = '';
		var newSpace2Width = '';
		var containerClassName = 'isc-layout-container';
		// store pixel sizes
		var currentSpace = dojo.contentBox( portletDiv.parentNode );
		
		newSpace1Width = Math.floor( currentSpace.w / 2 ) - 3;
		newSpace2Width = currentSpace.w - 6 - newSpace1Width;
		newSpace1Height = Math.floor( currentSpace.h / 2 ) - 3;
		newSpace2Height = currentSpace.h - 6 - newSpace1Height;
		var urlOrientation = 'horizontal';
		if ( clickedTarget.getAttribute( 'name' ) == 'IscCustomizerVertSplit' ) urlOrientation = 'vertical';

		// start assembling the placeholder that will eventually get the picker
		var newPortletWindow = document.createElement( 'TD' );
		newPortletWindow.className = 'isc-layout-window';
		//to set the td id
		var tempDiv = document.createElement( 'DIV' );
		tempDiv.innerHTML = data;
		var newPortletFragment = dojo.query( 'div[name="PortletFragment"]', tempDiv )[0];
		newPortletWindow.id = 'isc-layout-window' + newPortletFragment.id;
		var chooserDiv = document.createElement( 'DIV' );
		chooserDiv.setAttribute( 'name', 'PortletFragment' );
		// 254877. Set ARIA attributes to new split portlet window.
		chooserDiv.setAttribute('role', 'region');
		var portletTitleElementID = 'titleText.' + newPortletFragment.id;
		chooserDiv.setAttribute('aria-labelledby', portletTitleElementID);
		
		chooserDiv.style.zoom = 1;
		newPortletWindow.appendChild( chooserDiv );

		// figure out allocation of space and DOM changes and make them
		chooserDiv.style.overflow = 'auto';
		if ( urlOrientation == 'horizontal' ) { // horizontal split
			var sizer = customizer.createSizer( 'col' );
			var newRow = document.createElement( 'TR' );
			newRow.appendChild( newPortletWindow );
			/*248488 portletDiv.style.height = newSpace1Height + 'px'; */ /* console.log( METHODNAME + "Calling sizePortletDiv" ); */ customizer.sizePortletDiv( portletDiv, null, newSpace1Height );
			chooserDiv.style.width = currentSpace.w + 'px';
			chooserDiv.style.height = newSpace2Height + 'px';
			customizer.calcRelativePortletPercent( portletDiv );
			customizer.calcRelativePortletPercent( chooserDiv );
			if ( orientation == 'row') {
				// horizontal split on a row cell - must nest a new column table container
				// add a nested table with 2 rows and a sizer, single window cell in each row
				// put chooser in lower cell and move portlet to upper cell
				var nextSibling = portletDiv.parentNode.nextSibling; // might be null
				var containerTd = document.createElement( 'TD' );
				containerTd.style.padding = '0px';
				containerTd.style.height = '100%';				
				var containerTable = document.createElement( 'TABLE' );
				// 254877
				containerTable.setAttribute('role', 'presentation');
				
				containerTable.className = containerClassName;
				var containerTbody = document.createElement( 'TBODY' );
				var newRow1 = document.createElement( 'TR' );
				var newRow2 = document.createElement( 'TR' );
				containerTd.appendChild( containerTable );
				containerTable.appendChild( containerTbody );
				containerTbody.appendChild( newRow1 );
				newRow2.appendChild( newPortletWindow );
				newRow1.appendChild( portletDiv.parentNode ); // move current portlet into the new table
				dojo.place( sizer, newRow1, 'after' ); // add sizer
				dojo.place( newRow2, sizer, 'after' ); // add sizer
				if ( nextSibling == null ) {
					currentRow.appendChild( containerTd );
				} else {
					dojo.place( containerTd, nextSibling, 'before' );
				}
			} else {
				// horizontal split on a column cell - add a new column window cell (including row)
				// add a row with a sizer and a row with a new window cell with chooser in it
				dojo.place( sizer, currentRow, 'after' );
				dojo.place( newRow, sizer, 'after' );
			}
		} else {  // vertical split
			var sizer = customizer.createSizer( 'row' );
			/*248488 portletDiv.style.width = newSpace1Width + 'px'; */ /* console.log( METHODNAME + "Calling sizePortletDiv" ); */ customizer.sizePortletDiv( portletDiv, newSpace1Width, null );
			chooserDiv.style.width = newSpace2Width + 'px';
			chooserDiv.style.height = currentSpace.h + 'px';
			
			
			if ( orientation == 'row') {
				// vertical split on a row of cells - add a new row cell
				// add a sizer cell and an empty/chooser window cell to the current row
				dojo.place( sizer, portletDiv.parentNode, 'after' );
				dojo.place( newPortletWindow, sizer, 'after' );
			} else {
				// vertical split on a column of cells - must nest a new row container/table
				// add a nested table with 1 row, two window cells with sizer
				// move this portlet to left cell and put chooser in the right cell
				var nextSibling = portletDiv.parentNode.nextSibling; // might be null
				var containerTd = document.createElement( 'TD' );
				containerTd.style.padding = '0px';
				var containerTable = document.createElement( 'TABLE' );
				// 254877
				containerTable.setAttribute('role', 'presentation');
				
				containerTable.className = containerClassName;
				var containerTbody = document.createElement( 'TBODY' );
				var newRow = document.createElement( 'TR' );
				containerTd.appendChild( containerTable );
				containerTable.appendChild( containerTbody );
				containerTbody.appendChild( newRow );
				newRow.appendChild( portletDiv.parentNode ); // move current portlet into the new table
				dojo.place( sizer, portletDiv.parentNode, 'after' ); // add sizer
				dojo.place( newPortletWindow, sizer, 'after' );  // add new window
				if ( nextSibling == null ) {
					currentRow.appendChild( containerTd );
				} else {
					dojo.place( containerTd, nextSibling, 'before' );
				}
			}
		}
		// rescale the original portletDiv
		customizer.calcRelativePortletPercent( portletDiv );
		
		// insert the portlet with SM code
		customizer.insertPortletSM( newPortletWindow, data );
		
		//249133, if the wire table is expanded we don't send the resize event.
		var pageObj = IscPages.getPageObjectById(IscPages.currentPageId);
		var div = dijit.byId(pageObj.pageData.uniquePageName + "_Wires_Table_ID").domNode;
		if (div == null || div.style.display == "none") {
		  // reconcile sizes
		  if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer split' );
	  }
	},
	/*--- end splitter code ---*/
	/*--- start drag and drop code ---*/
	dndMouseDown: function( event ) {
		// start dnd - hide portlet and build a proxy to drag around
		customizer.draggedPortlet = customizer.getFirstAncestorByTag( event.currentTarget, 'DIV' );
		// set the drag proxy size to the pixel/rendered size of the TD containing the portlet
		customizer.sourceWindowWidth = /*TIP_DOJO_NS*/dojo.contentBox( customizer.draggedPortlet.parentNode ).w;
		customizer.sourceWindowHeight = /*TIP_DOJO_NS*/dojo.contentBox( customizer.draggedPortlet.parentNode ).h;
		var position = /*TIP_DOJO_NS*/dojo.coords( customizer.draggedPortlet, true );
		// build proxy for dragging around...
		var alltables = customizer.draggedPortlet.getElementsByTagName( 'TABLE' );
		var portletHeaderTable;
		for ( var i=0; i<alltables.length; i++ ) {
			if ( alltables[i].getAttribute( 'name' ) == 'portletHeaderTable' ) {
				portletHeaderTable = alltables[i].cloneNode( true );
				break;
			}
		}

    // A DIV wrapper for both portlet drag div and iframe
    // This DIV will cover the entire page...
		customizer.dragProxyDiv = document.createElement( 'DIV' );
		customizer.dragProxyDiv.style.width = "100%";
    // a big number for the height to cover the page
		customizer.dragProxyDiv.style.height = "2000px";
		customizer.dragProxyDiv.style.left = '0px';
		customizer.dragProxyDiv.style.top = '0px';
		customizer.dragProxyDiv.style.position = "absolute";

    // portlet drag div 
		customizer.dragProxy = document.createElement( 'DIV' );

		customizer.dragProxy.className = 'isc-layout-customizer-dnd-proxy';
		customizer.dragProxy.style.width = customizer.sourceWindowWidth + "px";
		customizer.dragProxy.style.height = customizer.sourceWindowHeight + "px";
		customizer.dragProxy.style.left = ( position.x - 1 ) + 'px';
		customizer.dragProxy.style.top = ( position.y - 1 ) + 'px';
		portletHeaderTable.className = 'isc-portlet-titlebar-bkg';
		customizer.dragProxy.appendChild( portletHeaderTable );
		customizer.dragProxyDiv.appendChild( customizer.dragProxy );

    // IFrame div for iframe
    // This div and iframe will cover the entire page
		customizer.dragProxyIFrameDiv = document.createElement( 'DIV' );
		customizer.dragProxyIFrameDiv.style.top = "0px";
		customizer.dragProxyIFrameDiv.style.left = "0px";
		customizer.dragProxyIFrameDiv.style.width = "100%";
		customizer.dragProxyIFrameDiv.style.height = "100%";
		customizer.dragProxyIFrameDiv.style.position = "absolute";
		customizer.dragProxyIFrameDiv.zIndex = "9993";

    var dragProxyIFrame = document.createElement( 'IFRAME' );
		dragProxyIFrame.style.position = "absolute";
		dragProxyIFrame.style.width = "100%";
		dragProxyIFrame.style.height = "100%";
		dragProxyIFrame.style.zIndex = "9994";
		if ( /*TIP_DOJO_NS*/dojo.isMozilla ) {
			dragProxyIFrame.style.display = "none";
		}
		dragProxyIFrame.style.backgroundColor = "transparent";
		dragProxyIFrame.style.filter = "alpha(opacity: 0.3)";
		dragProxyIFrame.style.opacity = "0";
		dragProxyIFrame.setAttribute('frameborder','0');
		dragProxyIFrame.setAttribute('border','0');
		dragProxyIFrame.setAttribute('scrolling','no');
		dragProxyIFrame.setAttribute('src', '');

		customizer.dragProxyIFrameDiv.appendChild(dragProxyIFrame);
		customizer.dragProxyDiv.appendChild(customizer.dragProxyIFrameDiv);
		customizer.dragProxyIFrame = dragProxyIFrame;
		/*TIP_DOJO_NS*/dojo.body().appendChild(customizer.dragProxyDiv);

		// hide the selected portlet
		customizer.draggedPortlet.style.visibility = 'hidden';
		// get ready to move stuff around
		customizer.dragProxy.clickOriginX = event.pageX;
		customizer.dragProxy.clickOriginY = event.pageY;
		customizer.dragProxy.deltaX = position.x -1 - event.pageX;
		customizer.dragProxy.deltaY = position.y -1 - event.pageY;
		customizer.dndonmousemove = /*TIP_DOJO_NS*/dojo.connect( document, "onmousemove", customizer, "dndThresholdMouseMove" );
		customizer.dndonmouseup = /*TIP_DOJO_NS*/dojo.connect( document, "onmouseup", customizer, "dndThresholdMouseUp" );

		event.preventDefault();   // stop text selection
		return false;
	},
	dndThresholdMouseUp: function( event ) {
		// if the mouse button is released before crossing the 3 pixel threshold we stop and clean up
		/*TIP_DOJO_NS*/dojo._destroyElement( customizer.dragProxyDiv );
		customizer.dragProxyDiv = null;
		//unhide the portlet
		customizer.draggedPortlet.style.width = customizer.sourceWindowWidth + "px";
		customizer.draggedPortlet.style.height = customizer.sourceWindowHeight + "px";
		customizer.draggedPortlet.style.visibility = 'visible';
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonmousemove );
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonmouseup );
		customizer.draggedPortlet = null;
		event.preventDefault();   // stop text selection
		return false;
	},
	dndThresholdMouseMove: function( event ) {
		// when first starting we wait to see if the dragging moves more than 3 pixels
		// once that happens we set up drop proxies, etc.
		if ( /*TIP_DOJO_NS*/dojo.isMozilla ) {
			// for Firefox, need to hide iframe and then make it visible for it to
			// go on top of the applet
			customizer.dragProxyIFrame.style.display='none';
		}
		if ( Math.abs( customizer.dragProxy.clickOriginX - event.pageX ) > 3 ||
				Math.abs( customizer.dragProxy.clickOriginY - event.pageY ) > 3 ) {
			/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonmousemove );
			/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonmouseup );
			customizer.dndonmousemove = /*TIP_DOJO_NS*/dojo.connect( document, "onmousemove", customizer, "dndMouseMove" );
			customizer.dndonmouseup = /*TIP_DOJO_NS*/dojo.connect( document, "onmouseup", customizer, "dndMouseUp" );
			customizer.dndonclick = /*TIP_DOJO_NS*/dojo.connect( document, "onclick", customizer, "dndClick" );
			// set body cursor so it doesn't flicker
			/*TIP_DOJO_NS*/dojo.body().style.cursor = 'move';
			// find all the portlets on this page except the one being dragged and set up drop
			// and highlight indicator proxies
			var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
			var rootTable = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", currentPageDiv )[0];
			if (rootTable == null) return;
			var alldivs = /*TIP_DOJO_NS*/dojo.query( 'div[name="PortletFragment"]', currentPageDiv );
			for ( var i=0; i<alldivs.length; i++ ) {
				if ( alldivs[i] != customizer.draggedPortlet ) {
					var targetWindow = alldivs[i];
					var targetWidth = /*TIP_DOJO_NS*/dojo.contentBox( targetWindow.parentNode ).w;
					var targetHeight = /*TIP_DOJO_NS*/dojo.contentBox( targetWindow.parentNode ).h;
					var position = /*TIP_DOJO_NS*/dojo.coords( targetWindow, true );
					var highlightproxy = document.createElement( 'DIV' );
					var eventproxy = document.createElement( 'DIV' );
					eventproxy.proxiedTarget = targetWindow; // store reference (is this the memory leak?)
					eventproxy.highlightProxy = highlightproxy; // store reference
					eventproxy.className = 'isc-layout-customizer-dnd-eventtarget';
					highlightproxy.className = 'isc-layout-customizer-dnd-dropzone';
					highlightproxy.style.height = targetHeight + "px";
					eventproxy.style.height = targetHeight + "px";
					highlightproxy.style.zoom = 1;
					eventproxy.style.zoom = 1;
					// handle box model differences btwn FF and IE (border width inside or outside)
					if ( /*TIP_DOJO_NS*/dojo.isIE ) {
						highlightproxy.style.width = (targetWidth + 4) + "px";
						eventproxy.style.width = (targetWidth + 4) + "px";
						highlightproxy.style.left = (position.x - 3) + "px";
						highlightproxy.style.top = position.y + "px";
						eventproxy.style.left = (position.x - 3) + "px";
						eventproxy.style.top = position.y + "px";
					} else {
						highlightproxy.style.width = targetWidth + "px";
						eventproxy.style.width = targetWidth + "px";
						highlightproxy.style.left = (position.x - 6) + "px";
						highlightproxy.style.top = (position.y - 3) + "px";
						eventproxy.style.left = (position.x - 6) + "px";
						eventproxy.style.top = (position.y - 3) + "px";
					}
					eventproxy.setAttribute( 'name', 'targetproxies' );
					highlightproxy.setAttribute( 'name', 'targetproxies' );
					/*TIP_DOJO_NS*/dojo.connect( eventproxy, "onmousemove", customizer, "dndDropTargetMouseOver" );
					/*TIP_DOJO_NS*/dojo.connect( eventproxy, "onmouseout", customizer, "dndDropTargetMouseOut" );
					/*TIP_DOJO_NS*/dojo.place( highlightproxy, rootTable, 'after');
					/*TIP_DOJO_NS*/dojo.place( eventproxy, rootTable, 'after');
				}
			}
			/*TIP_DOJO_NS*/dojo.style( currentPageDiv, 'position', '' ); // temporarily remove to work around IE bug
		}
		event.preventDefault();   // stop text selection
		return false;
	},
	dndDropTargetMouseOver: function( event ) {
		// highlight drop zone proxies as we mouse over them with a dragged portlet
		var eventproxy = event.currentTarget;
		eventproxy.highlightProxy.className = 'isc-layout-customizer-dnd-dropzone-highlight';
		customizer.currentTargetPortlet = eventproxy.proxiedTarget;
		event.preventDefault();   // stop text selection
		return true;
	},
	dndDropTargetMouseOut: function( event ) {
		// undo the highlighting
		var eventproxy = event.currentTarget;
		eventproxy.highlightProxy.className = 'isc-layout-customizer-dnd-dropzone';
		customizer.currentTargetPortlet = null;
		event.preventDefault();   // stop text selection
		return true;
	},
	dndMouseMove: function( event ) {
		// animate the drag proxy to move with the cursor
		// for firefox, need to reset the iframe display for it to go on top of applet
		if ( /*TIP_DOJO_NS*/dojo.isMozilla ) {
			customizer.dragProxyIFrame.style.display='none';
			customizer.dragProxyIFrame.style.display='block';
		}
		customizer.dragProxy.style.left = ( event.pageX + customizer.dragProxy.deltaX ) + 'px';
		customizer.dragProxy.style.top = ( event.pageY + customizer.dragProxy.deltaY ) + 'px';
		event.preventDefault();   // stop default behaviour
		return true;
	},
	dndMouseUp: function( event ) {
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		// we've moved more than 3 pixels and the portlet has now been dropped
		// we clean up the proxies and decide if it was dropped on a valid drop zone
		// if so we swap portlets - otherwise just put it back
		/*TIP_DOJO_NS*/dojo.style( currentPageDiv, 'position', 'absolute' );  // replace what was temporarily removed to work around IE bug

		/*TIP_DOJO_NS*/dojo._destroyElement( customizer.dragProxyIFrame );
		/*TIP_DOJO_NS*/dojo._destroyElement( customizer.dragProxyIFrameDiv );
		/*TIP_DOJO_NS*/dojo._destroyElement( customizer.dragProxy );
		/*TIP_DOJO_NS*/dojo._destroyElement( customizer.dragProxyDiv );
		customizer.dragProxy = null;
		customizer.dragProxyDiv = null;
		customizer.dragProxyIFrame = null;
		customizer.dragProxyIFrameDiv = null;
		// FIXME: this leaks around 5460K of memory in IE for the complex layout each time
		// need a new cleaner way to do this
		var divs = currentPageDiv.getElementsByTagName( 'DIV' );
		var proxyDivs = new Array();
		for ( var i=0; i<divs.length; i++ ) {
			if ( divs[i].className.match( /^isc-layout-customizer-dnd-/ ) != null ) {
				proxyDivs[ proxyDivs.length ] = divs[i];
			}
		}
		for ( var i=0; i<proxyDivs.length; i++ ) {
			// may need to remove the event handlers first?
			proxyDivs[i].parentNode.removeChild( proxyDivs[i] );
		}
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonmousemove );
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonmouseup );
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonclick );
		// unset the body cursor
		/*TIP_DOJO_NS*/dojo.body().style.cursor = '';
		var sourceCell = customizer.draggedPortlet.parentNode;
		if ( customizer.currentTargetPortlet != null ) {
			// swap the portlets
			var targetCell = customizer.currentTargetPortlet.parentNode;
			customizer.originalTargetWidth = /*TIP_DOJO_NS*/dojo.marginBox( customizer.currentTargetPortlet ).w;
			customizer.originalTargetHeight = /*TIP_DOJO_NS*/dojo.marginBox( customizer.currentTargetPortlet ).h;
			var portletstandin = document.createElement( 'DIV' );
			portletstandin.style.width = /*TIP_DOJO_NS*/dojo.style( targetCell, 'width' ) + "px";
			portletstandin.style.height = /*TIP_DOJO_NS*/dojo.style( targetCell, 'height' ) + "px";
			var removedTargetPortlet = customizer.replaceNode( customizer.currentTargetPortlet, portletstandin );
			removedTargetPortlet.style.width = customizer.sourceWindowWidth + "px";
			removedTargetPortlet.style.height = customizer.sourceWindowHeight + "px";
			customizer.calcRelativePortletPercent( removedTargetPortlet );
			var removedSourcePortlet = customizer.replaceNode( customizer.draggedPortlet, removedTargetPortlet );
			removedSourcePortlet.style.width = customizer.originalTargetWidth + "px";
			removedSourcePortlet.style.height = customizer.originalTargetHeight + "px";
			customizer.calcRelativePortletPercent( removedSourcePortlet );
			customizer.replaceNode( portletstandin, removedSourcePortlet );
			portletstandin = null;
			// send framework event to notify portlets that want to know about resizes
			iscPortlet.sendResizeEvent( 'customizer portlet swap' ); // this will also audit sizes

			// Force re-render on IE to handle iframes (IE does not re-render one of the iframes after the swap for some reason)
			if( /*TIP_DOJO_NS*/dojo.isIE ) {
				var isolationIframes = UIElement.getElementsByName( removedSourcePortlet, "isc_iframe" );
				if( isolationIframes.length > 0 ) {
					for( var i = 0; i < isolationIframes.length; i++ ) {
						isolationIframes[i].width="99%";
					}
				}
				isolationIframes = UIElement.getElementsByName( removedTargetPortlet, "isc_iframe" );
				if( isolationIframes.length > 0 ) {
					for( var i = 0; i < isolationIframes.length; i++ ) {
						isolationIframes[i].width="99%";
					}
				}
			}

			// tell the server side what was done 
			var uid = currentPageDiv.modelObject.pageData.tid;
			// TODO: replace this (and all other occurences) with the new dojo content param...
			var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
			if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
				uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
			var url = contextRoot + "/customizer.do?action=dad"
						+ "&moduleRef=" + currentPageDiv.modelObject.pageData.moduleRef
						+ "&pageId=" + uniquePageName
			                        + '&XSS=' + top.window.XSS
						+ "&windowId=" + customizer.draggedPortlet.id
						+ "&destWindowId=" + customizer.currentTargetPortlet.id;
			if ( uid ) url += '&uid=' + uid;
			url = encodeURI( url );
			/*TIP_DOJO_NS*/dojo.xhrGet( {
				url: url,
				load: function( type, data, evt ) { },
				handleAs: "text"
			} );
		} else {
			// no swap - restore original size
			/*
			customizer.draggedPortlet.style.width = customizer.sourceWindowWidth;
			customizer.draggedPortlet.style.height = customizer.sourceWindowHeight;
			*/
		}
		customizer.draggedPortlet.style.visibility = 'visible';
		customizer.draggedPortlet = null;
		customizer.currentTargetPortlet = null;
		event.preventDefault();   // stop default behaviour
		return true;
	},
	dndClick: function( event ) {
		// we don't want click events - using mouse up and down instead
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.dndonclick );
		event.preventDefault();   // stop default behaviour
		return true;
	},
	/*--- end drag and drop code ---*/
	/*--- start sizing code ---*/
	sizeMouseDown: function( event ) {
		customizer.sizePage = IscPages.getPageElementById( IscPages.currentPageId );
		customizer.sizeOriginX = event.pageX;
		customizer.sizeOriginY = event.pageY;
		customizer.smallestX = new Array();
		customizer.smallestY = new Array();
		var sizerTd = event.currentTarget;
		var sizerTdName = sizerTd.getAttribute( 'name' );
		// set body cursor so it doesn't flicker
		customizer.cursor = /*TIP_DOJO_NS*/dojo.style( sizerTd, 'cursor' );
		/*TIP_DOJO_NS*/dojo.body().style.cursor = customizer.cursor;
		if ( ( sizerTdName != null ) && ( sizerTdName.match( /^layoutsizer/ ) != null ) ) {
			if ( sizerTdName == 'layoutsizerRight' ) {
				customizer.sizerOrientation = 'row';
			} else {
				customizer.sizerOrientation = 'col';
			}
			customizer.previousNeighbors = customizer.getAdjacentPortlets( sizerTd, 'previous' );
			customizer.nextNeighbors = [];
		} else {
			customizer.sizerOrientation = customizer.getOrientation( sizerTd );
			customizer.previousNeighbors = customizer.getAdjacentPortlets( sizerTd, 'previous' );
			customizer.nextNeighbors = customizer.getAdjacentPortlets( sizerTd, 'next' );
		}
		customizer.minPortletHeight = 40; // this is determined by the height of the draggie image for now
		customizer.minPortletWidth = 40; // this is determined by the width of the draggie image for now
		// customizer.minPortletHeight = customizer.getPortletHeaderHeight( customizer.previousNeighbors[0] );

		var pageHeight = /*TIP_DOJO_NS*/dojo.dnd.getViewport().h + 'px';
		var moveEventTarget = document.createElement( 'DIV' );
		moveEventTarget.id = 'customizerSizeEventTarget';
		moveEventTarget.style.position = 'absolute';
		moveEventTarget.style.top = '0px';
		moveEventTarget.style.left = '0px';
		moveEventTarget.style.width = '100%';
		moveEventTarget.style.height = pageHeight;
		moveEventTarget.style.filter = "alpha(opacity: 0.3)";
		moveEventTarget.style.backgroundColor = "white";
		moveEventTarget.style.opacity = 0;
		moveEventTarget.style.zIndex = 10000;

		// IFrame div for iframe
		customizer.moveEventIFrameDiv = document.createElement( 'DIV' );
		customizer.moveEventIFrameDiv.style.top = "0px";
		customizer.moveEventIFrameDiv.style.left = "0px";
		customizer.moveEventIFrameDiv.style.width = "100%";
		customizer.moveEventIFrameDiv.style.height = pageHeight;
		customizer.moveEventIFrameDiv.style.position = "absolute";
		customizer.moveEventIFrameDiv.style.zIndex = "9999";

		var moveEventIFrame = document.createElement( 'IFRAME' );
		moveEventIFrame.style.position = "absolute";
		moveEventIFrame.style.top = "0px";
		moveEventIFrame.style.left = "0px";
		moveEventIFrame.style.width = "100%";
		moveEventIFrame.style.height = pageHeight;
		moveEventIFrame.style.zIndex = "9998";
		moveEventIFrame.style.backgroundColor = "transparent";
		moveEventIFrame.style.filter = "alpha(opacity: 0.3)";
		moveEventIFrame.style.opacity = "0";
		if ( /*TIP_DOJO_NS*/dojo.isMozilla ) {
			moveEventIFrame.style.display = "none";
		}
		moveEventIFrame.setAttribute('frameborder','0');
		moveEventIFrame.setAttribute('border','0');
		moveEventIFrame.setAttribute('scrolling','no');
		moveEventIFrame.setAttribute('src', '');
		customizer.moveEventIFrame = moveEventIFrame;
		customizer.moveEventIFrameDiv.appendChild(moveEventIFrame);

		customizer.ondragstart = /*TIP_DOJO_NS*/dojo.connect( document, "ondragstart", /*TIP_DOJO_NS*/dojo, "stopEvent", false );
		customizer.onselectstart = /*TIP_DOJO_NS*/dojo.connect( document, "onselectstart", /*TIP_DOJO_NS*/dojo, "stopEvent", false );
		customizer.sizeonmousemove = /*TIP_DOJO_NS*/dojo.connect( moveEventTarget, "onmousemove", customizer, "sizeMouseMove" );
		customizer.sizeonmouseup = /*TIP_DOJO_NS*/dojo.connect( moveEventTarget, "onmouseup", customizer, "sizeMouseUp" );

		// add the iframe div first
		/*TIP_DOJO_NS*/dojo.place( customizer.moveEventIFrameDiv, /*TIP_DOJO_NS*/dojo.body(), 'first' );
		/*TIP_DOJO_NS*/dojo.place( moveEventTarget, /*TIP_DOJO_NS*/dojo.body(), 'first' );

		event.preventDefault();
		return false;
	},
	sizeMouseMove: function( event ) {
		if ( /*TIP_DOJO_NS*/dojo.isMozilla && customizer.moveEventIFrame ) {
			customizer.moveEventIFrame.style.display = "none";
			customizer.moveEventIFrame.style.display = "block";
		}
		var deltaX = Number( event.pageX - customizer.sizeOriginX );
		var deltaY = Number( event.pageY - customizer.sizeOriginY );
		if ( customizer.smallestX == undefined || customizer.smallestX == null ) {
			// if the mouse was released outside the browser window behave reasonably
			customizer.sizeMouseUp( event );
			return;
		}
		if ( deltaX < -( customizer.smallestX['previous'] - customizer.minPortletWidth ) ) {
			deltaX = -( customizer.smallestX['previous'] - customizer.minPortletWidth );
		} else if ( deltaX > ( customizer.smallestX['next'] - customizer.minPortletWidth ) ) {
			deltaX = customizer.smallestX['next'] - customizer.minPortletWidth;
		}
		if ( deltaY < -( customizer.smallestY['previous'] - customizer.minPortletHeight ) ) {
			deltaY = -( customizer.smallestY['previous'] - customizer.minPortletHeight );
		} else if ( deltaY > ( customizer.smallestY['next'] - customizer.minPortletHeight ) ) {
			deltaY = customizer.smallestY['next'] - customizer.minPortletHeight;
		}
		// size portlets previous to this sizer
		for ( var i=0; i<customizer.previousNeighbors.length; i++ ) {
			var div = customizer.previousNeighbors[i];
			var origHeight = Number( div.getAttribute( 'origheight' ) );
			if ( customizer.sizerOrientation == 'row' ) {
				var origWidth = Number( div.getAttribute( 'origwidth' ) );
				//239473 under RTL env, the width calculate algorithm should be reverse
				if (customizer.isRTL == true)  
					div.style.width = ( origWidth - deltaX ) + 'px';
				else
					div.style.width = ( origWidth + deltaX ) + 'px';
			} else {
				div.style.height = ( origHeight + deltaY ) + 'px';
			}
		}
		// size portlets after to this sizer
		for ( var i=0; i<customizer.nextNeighbors.length; i++ ) {
			var div = customizer.nextNeighbors[i];
			var origHeight = Number( div.getAttribute( 'origheight' ) );
			if ( customizer.sizerOrientation == 'row' ) {
				var origWidth = Number( div.getAttribute( 'origwidth' ) );
				//239473 under RTL env, the width calculate algorithm should be reverse
				if (customizer.isRTL == true)
					div.style.width = ( origWidth + deltaX ) + 'px';
				else
					div.style.width = ( origWidth - deltaX ) + 'px';
			} else {
				div.style.height = ( origHeight - deltaY ) + 'px';
			}
		}
		event.stopPropagation();  // stop event bubbling up
		event.preventDefault();   // stop default behaviour
		return true;
	},
	sizeMouseUp: function( event ) {
		// finished dragging
		// send AJAX to the sever for each changed size
		// clean up events and references
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.sizeonmousemove );
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.sizeonmouseup );
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.onselectstart );
		/*TIP_DOJO_NS*/dojo.disconnect( customizer.ondragstart );
		customizer.onselectstart = null;
		customizer.ondragstart = null;
		/*TIP_DOJO_NS*/dojo._destroyElement( /*TIP_DOJO_NS*/dojo.byId( 'customizerSizeEventTarget' ) );

		// process size changes for all effected portlets
		if ( customizer.previousNeighbors ) {
			for ( var i=0; i<customizer.previousNeighbors.length; i++ ) {
				customizer.sendPortletSize( customizer.previousNeighbors[i] );
			}
		}
		if ( customizer.nextNeighbors ) {
			for ( var i=0; i<customizer.nextNeighbors.length; i++ ) {
				customizer.sendPortletSize( customizer.nextNeighbors[i] );
			}
		}
		// clean up stored row sizes
		customizer.sizeonmousemove = null;
		customizer.sizeonmouseup = null;
		customizer.previousNeighbors = null;
		customizer.nextNeighbors = null;
		customizer.sizerOrientation = null;
		customizer.smallestX = null;
	 	customizer.smallestY = null;
		customizer.minPortletHeight = null;
		customizer.cursor = null;
		customizer.sizePage = null;
		/*TIP_DOJO_NS*/dojo.body().style.cursor = ''; // unset the body cursor
		event.preventDefault();   // stop default behaviour
		// send framework event to notify portlets that want to know about resizes
		iscPortlet.sendResizeEvent( 'customizer portlet resize' );

		// clean up iframe div
		/*TIP_DOJO_NS*/dojo._destroyElement( customizer.moveEventIFrame );
		customizer.moveEventIFrame = null;
		/*TIP_DOJO_NS*/dojo._destroyElement( customizer.moveEventIFrameDiv );
		customizer.moveEventIFrameDiv = null;
		return true;
	},
	/*--- end sizing code ---*/
	/*--- start deletion code ---*/
	getSiblingContainers: function( windowTd ) {
		var containingTable = customizer.getAncestors( windowTd, customizer.checkIfContainerTable, true );
		var siblingTds = [];
		for ( var r=0; r<containingTable.rows.length; r++ ) {
			for ( var c=0; c<containingTable.rows[r].cells.length; c++ ) {
				var td = containingTable.rows[r].cells[c];
				if ( td !== windowTd && td.className.match(/^isc-layout-sizebar-/ ) == null ) {
					siblingTds.push( td );
				}
			}
		}
		return siblingTds;
	},
	removeWindow: function( windowTd ) {
        var deletedWindow = windowTd;
		var deletedSizer = null;
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var layoutType = currentPageDiv.modelObject.pageData.layoutType;
		if (layoutType != "Freeform"){// handle removing a window in either orientation and a sizer
			if ( customizer.getOrientation( windowTd ) == 'col' ) {
				// remove a TR and a TD and a sizer TR/TD
				deletedWindow = windowTd.parentNode;
				if ( deletedWindow.rowIndex == 0 ) {
					// this is the first row (and there are more)
					if ( deletedWindow.cells[deletedWindow.cells.length - 1].className.match(/^isc-layout-sizebar-/ ) != null ) {
						// if the TR to delete is the top one in a pixel-based root table, need to move the right edge sizer
						deletedWindow.parentNode.rows[2].appendChild( deletedWindow.cells[deletedWindow.cells.length - 1] );
					}
					deletedSizer = deletedWindow.parentNode.rows[1];
				} else {
					deletedSizer = deletedWindow.parentNode.rows[deletedWindow.rowIndex - 1];
				}

			}
			else {
				// remove a TD and a sizer TD
				deletedWindow = windowTd;
				if ( windowTd.cellIndex == 0 ) {
					// this is the first cell
					deletedSizer = deletedWindow.parentNode.cells[1];
				} else {
					deletedSizer = deletedWindow.parentNode.cells[deletedWindow.cellIndex - 1];
				}
			}
		}
		UIElement.destroyElement( deletedWindow );
		UIElement.destroyElement( deletedSizer );
	},
	moveWindowUp: function( windowTd ) {
		var containingTable = customizer.getAncestors( windowTd, customizer.checkIfContainerTable, true );
		var containingTd = containingTable.parentNode;
		var leaker = customizer.replaceNode( containingTd, windowTd );
		/*TIP_DOJO_NS*/dojo._destroyElement( leaker ); // prevent IE memory leak
	},
	mergeContainerUp: function( containerTd ) {
		var childrenToMove = [];
		var containerToReplace = null; // either TD or TR
		var containerToMerge = containerTd.getElementsByTagName( 'TABLE' )[0];
		var containingTable = customizer.getAncestors( containerTd, customizer.checkIfContainerTable, true );
		if ( customizer.getOrientation( containerToMerge ) == 'col' ) {
			childrenToMove = containerToMerge.rows;
			containerToReplace = containingTable.parentNode.parentNode; // a TR
			if ( containerToReplace.cells[containerToReplace.cells.length - 1].className.match(/^isc-layout-sizebar-/ ) != null ) {
				// if the TR to replace is the top one in a pixel-based root table, need to move the right edge sizer
				childrenToMove[0].appendChild( containerToReplace.cells[containerToReplace.cells.length - 1] );
			}
		} else {
			childrenToMove = containerToMerge.rows[0].cells;
			containerToReplace = containingTable.parentNode; // a TD
		}
		containerToReplace.style.display = 'none';
		while ( childrenToMove.length > 0 ) {
			/*TIP_DOJO_NS*/dojo.place( childrenToMove[0], containerToReplace, 'before' );
		}
		/*TIP_DOJO_NS*/dojo._destroyElement( containerToReplace );
	},
	getSpaceRecipients: function( windowTd ) {
		// get adjacent sizers but only within the same container
		var nextSizer = null;
		var previousSizer = null;
		if ( customizer.sizerOrientation == 'col' ) {
			var rowIndex = windowTd.parentNode.rowIndex;
			if ( rowIndex != 0 ) previousSizer = windowTd.parentNode.parentNode.rows[rowIndex - 1].cells[0];
			nextSizer = windowTd.parentNode.parentNode.rows[rowIndex + 1];
			if ( nextSizer === undefined ) nextSizer = null;
// TODO: take out layout sizer stuff
			if ( nextSizer != null &&
					nextSizer.cells[0].getAttribute( 'name' ) != null &&
					nextSizer.cells[0].getAttribute( 'name' ).match( /^layoutsizer/ ) != null ) {
				// this would be the layout sizer in pixel mode - ignore it
				nextSizer = null;
			} else if ( nextSizer != null ) {
				nextSizer = nextSizer.cells[0];
			}
		} else {
			var cellIndex = windowTd.cellIndex;
			if ( cellIndex != 0 ) previousSizer = windowTd.parentNode.cells[cellIndex - 1];
			nextSizer = windowTd.parentNode.cells[cellIndex + 1];
			if ( nextSizer == undefined ) nextSizer = null;
// TODO: take out layout sizer stuff
			if ( nextSizer != null &&
					nextSizer.getAttribute( 'name' ) != null &&
					nextSizer.getAttribute( 'name' ).match( /^layoutsizer/ ) != null ) {
				// this would be the layout sizer in pixel mode - ignore it
				nextSizer = null;
			}
		}
		var previousPortlets = [];
		var nextPortlets = [];
		if ( previousSizer != null ) {
			previousPortlets = customizer.getAdjacentPortlets( previousSizer, 'previous' );
		}
		if ( nextSizer != null ) {
			nextPortlets = customizer.getAdjacentPortlets( nextSizer, 'next' );
		}
		return { previous: previousPortlets, next: nextPortlets };
	},
	aboutPortlet: function( portletId ) {
	 //     defect 258353    
			 // var portletDiv = dojo.byId(portletId).children[0];
			 var portletDiv = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]',/*TIP_DOJO_NS*/dojo.byId(portletId))[0];
			  var portletID = portletDiv.modelObject.portletData.portletID;
			  
			  var url=contextRoot+"/html/isclite/AboutPage.jsp?TIP.portletID="+portletID;
			  //      defect 258353  
			  window.open(url,'About_Page','location=0,resizable=yes,scrollbars=yes,menubar=no,toolbar=no,status=no,width=500,height=400').focus();
		},
	deleter: function( oid ) {
		iscPopupMenuQuickHide();
		SMUtils.closeEditDialog();
		// thus assumes a distilled layout
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = /*TIP_DOJO_NS*/dojo.byId(oid); 
		//case when the menu is a child of body and not part of the portlet
		if(portletDiv == null) {			
			var parentDivId = null;
			if (event.currentTarget.offsetParent.id.match('iscEditPopupMenu_')) {
				parentDivId = event.currentTarget.offsetParent.id.replace('iscEditPopupMenu_', '') ;  ///strip oid from edit defaults menu id
			}
			portletDiv = document.getElementById(parentDivId);
		}
		var portletId = portletDiv.id;
        
        // 246012
        iWidgetUtils.removeIWidgetsInMarkup(portletDiv);
		customizer.removeWiresFromSummaryTable(currentPageDiv,portletDiv);
       
		var windowTd = portletDiv.parentNode;
		
		var layoutType = currentPageDiv.modelObject.pageData.layoutType;
		//if freeform page then just remove the window
		if (layoutType == "Freeform"){
			customizer.removeWindow( portletDiv );
		}
		else{
			customizer.sizerOrientation = customizer.getOrientation( windowTd );
			var deltaX = /*TIP_DOJO_NS*/dojo.contentBox( windowTd ).w;
			var deltaY = /*TIP_DOJO_NS*/dojo.contentBox( windowTd ).h;
			var siblingTds = customizer.getSiblingContainers( windowTd );
			var containingTable = customizer.getAncestors( windowTd, customizer.checkIfContainerTable, true );
			var portletsToSize = customizer.getSpaceRecipients( windowTd );
			if ( customizer.checkIfRootTable( containingTable ) ) {
				// window is in root container
				if ( siblingTds.length == 0 ) {
					// since this is the last portlet on the page, replace it with the picker
					customizer.replacePortlet( oid );
					return true;
				} else {
					customizer.removeWindow( windowTd );
				}
			} else if ( siblingTds.length > 1 ) {
				// more than one sibling - just remove this window
				customizer.removeWindow( windowTd );
			} else if ( /*TIP_DOJO_NS*/dojo.hasClass( siblingTds[0], 'isc-layout-window' ) ) {
				// the one sibling contains just a window/portlet
				// move that window into the parent container
				customizer.moveWindowUp( siblingTds[0] );
			} else {
				// the one sibling contains a container
				// put the children of the container in the parent and throw away the container
				customizer.mergeContainerUp( siblingTds[0] );
			}
		}

		var uid = currentPageDiv.modelObject.pageData.tid;
		var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
		if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
			uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
		var url = contextRoot + '/customizer.do?action=delete'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + uniquePageName
			                + '&XSS=' + top.window.XSS
					+ '&windowId=' + portletId;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text"
		} );
		if (layoutType != "Freeform"){
			// if there are both previous and next porlets, half the width (for row) or height (for col) 
			// and add that to all of the porlets.  If there are only previous or only next portlets,
			// add the full width/height to the portlets.

			var deltaX1 = deltaX;
			var deltaY1 = deltaY;
			if ( portletsToSize.previous.length != 0 && portletsToSize.next.length != 0 ) {
				deltaX1 = Math.floor( ( deltaX + 6 ) / 2 );
				deltaX = Number( deltaX - deltaX1 );
				deltaY1 = Math.floor( ( deltaY + 6 ) / 2 );
				deltaY = Number( deltaY - deltaY1 );
			} else {
				deltaX += 6;
				deltaY += 6;
				deltaX1 += 6;
				deltaY1 += 6;
			}
			// process size changes for all effected portlets
			for ( var i=0; i<portletsToSize.previous.length; i++ ) {
				var width = /*TIP_DOJO_NS*/dojo.contentBox( portletsToSize.previous[i] ).w;
				var height = /*TIP_DOJO_NS*/dojo.contentBox( portletsToSize.previous[i] ).h;
				var newWidth = Number( width + deltaX );
				var newHeight = Number( height + deltaY );
				if ( customizer.sizerOrientation == 'col' ) {
					portletsToSize.previous[i].style.height = newHeight + 'px';
				} else {
					portletsToSize.previous[i].style.width = newWidth + 'px';
				}
				customizer.sendPortletSize( portletsToSize.previous[i] );
			}
			for ( var i=0; i<portletsToSize.next.length; i++ ) {
				var width = /*TIP_DOJO_NS*/dojo.contentBox( portletsToSize.next[i] ).w;
				var height = /*TIP_DOJO_NS*/dojo.contentBox( portletsToSize.next[i] ).h;
				var newWidth = Number( width + deltaX1 );
				var newHeight = Number( height + deltaY1 );
				if ( customizer.sizerOrientation == 'col' ) {
					portletsToSize.next[i].style.height = newHeight + 'px';
				} else {
					portletsToSize.next[i].style.width = newWidth + 'px';
				}
				customizer.sendPortletSize( portletsToSize.next[i] );
				
			}
			if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer portlet deletion' );
			customizer.sizerOrientation = null;
			
			//enable/disable the Save button according to the presence of Portlet Picker on the page
			var pickers = document.getElementsByName("thepicker");
			if(pickers.length == 0)
			{
				var saveBtn = /*TIP_DOJO_NS*/dojo.query( 'input[name="page.titlebar.save"]', currentPageDiv)[0];
				//var saveBtn = document.getElementById("page.titlebar.save");		
				//I used dojo.query to get element instead of document.getElementById
				saveBtn.disabled = false;
			}
			}
		else{
			var contentArea = document.getElementById(currentPageDiv.modelObject.pageData.uid+"FreeformContent");
			var portlets = /*TIP_DOJO_NS*/dojo.query('div',contentArea);
			if (portlets.length == 0) {
				var saveBtn = /*TIP_DOJO_NS*/dojo.query('input[id="page.titlebar.save"]',currentPageDiv)[0];
				saveBtn.disabled= true;
			}
		}
	},
    
    removeWiresFromSummaryTable:function(pageDiv,portletDiv){
        var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
	  var isNewPage = pageDiv.modelObject.pageData.newPage;
        var pii = null;
	  if(isNewPage == "true") {
		pii = portletDiv.id;      
	  }else {
		if (pageDiv.modelObject.pageData.layoutType == "Freeform") {
			var iscPortlet = dojo.byId(portletDiv);
		    	if(iscPortlet) {
				var portletDataObject = iscPortlet.modelObject.portletData;	
		    	 	pii = portletDataObject.basePii;
		    	}
		}else {
			for(i in portletDiv.childNodes){
                  	if(portletDiv.childNodes[i].tagName == "TABLE"){
                	      	pii = portletDiv.childNodes[i].modelObject.portletData.basePii;
                	       	break;
           		  	}	
        	      }
		}
		
	  }

        if(piiToPWIMap[pii]){
     	    pii = piiToPWIMap[pii];
        }
        
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId);
		if(!storeManager) return;

		var wireStore = storeManager.getWiresStore();
               var eventStore = storeManager.getEventsStore();
        
        function removeWires(item){
	if(item.type=="wire"){
            var currWireSource = wireStore.getValue(item,"wireSource");
            var currWireSourcePii = wireStore.getValue(currWireSource,"pii");
	     var currWireTarget = wireStore.getValue(item,"wireTarget");
            var currWireTargetPii = wireStore.getValue(currWireTarget,"pii");
           
	   if(pii==currWireSourcePii){	
            // deleteing wires with source pii that equals the pii of the deleted portlet
            // wires are deleted from the JSON store and are remoced from the table

               wireStore.deleteItem(item, true);

            }
	     if(pii==currWireTargetPii){	
            // deleteing wires with target pii that equals the pii of the deleted portlet
            // wires are deleted from the JSON store and are remoced from the table

               wireStore.deleteItem(item, true);
		}
            }
		};
        
        if(pii && pii != null){
            wireStore.fetch({type:'wire',onItem: removeWires});
        }
        
         function removeEvents(item){
            if(item.type=="event"){
            if(pii==item.pii[0]){
            // deleteing wires with source pii that equals the pii of the deleted portlet
            // wires are deleted from the JSON store and are remoced from the table
              eventStore.deleteItem(item);
              storeManager.updateSourceEventDialog();
              
            }
	   } 
		};
        
        if(pii && pii !=null){
            eventStore.fetch({type:'event',onItem: removeEvents});
        }
    
    },
	/*--- end deletion code ---*/
	/*--- begin replacement code ---*/
	replacePortlet: function( oid ) {
	        iscPopupMenuQuickHide();
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = /*TIP_DOJO_NS*/dojo.byId(oid); 
		var iscPortlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', portletDiv );
		if(iscPortlets.length!=1){
			return;
			}
		var iscPortlet = iscPortlets[0];
		var portletPii = iscPortlet.modelObject.portletData.basePii;     	
		
		var theRealPWI = piiToPWIMap[portletDiv.id];
		var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId);
		var eventStore = storeManager.getEventsStore();
	        var piiToDestroy=[];
		
		var items=eventStore._arrayOfAllItems;
	        for(var i=0; i<items.length;i++){
		
			       var item=items[i];
			      
			if(item!=null){	
			        itemId=item.id[0];
				
			        var index=itemId.indexOf('h');
			        index=index-1;
			        var pii=itemId.substring(0,index);
			       
				if(typeof(theRealPWI)=="undefined"){
					theRealPWI=portletPii;
				}
				
				
			       if(item.type=="event" || item.type=="parameter" ){
					if(pii==theRealPWI){
						eventStore.deleteItem(item);	
					}
				}
			
			}
		}
		
	      piiToDestroy.push(theRealPWI);
	      eventStore.save();

        customizer.removeWiresFromSummaryTable(currentPageDiv,portletDiv);	             
	    customizer.destroyPiis(uniquePageName,piiToDestroy);       
	 	customizer.destroyEventTables(currentPageDiv);
          	
		var portletId = portletDiv.id;
		var windowTd = portletDiv.parentNode;
		portletDiv.innerHTML = '';
		var uid = currentPageDiv.modelObject.pageData.tid;
		var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
		if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
			uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
		var url = contextRoot + '/customizer.do?action=deletecontent'
					+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
					+ '&pageId=' + uniquePageName
			                + '&XSS=' + top.window.XSS
					+ '&windowId=' + portletId;
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			load: function( response, ioargs ) { customizer.insertPortletSM( windowTd, response ) },
			handleAs: "text"
		} );
	},
	/*--- end replacement code ---*/
	/*--- begin setup wires drag and drop code ---*/

  wireDropTargets: {},
	
	setupWiresDragAndDrop: function( curPageElem ){
		try {
		  var pageId = curPageElem.modelObject.pageData.uid;
			if (typeof this.wireDropTargets[pageId] != "undefined" && this.wireDropTargets[pageId] != null) {
				console.log("this.wireDropTargets[pageId] already exists");
        return;
			}
			console.log("creating this.wireDropTargets[pageId]");
			this.wireDropTargets[pageId] = new Array();
		} catch(e) {
			
		}
       
		/*TIP_DOJO_NS*/dojo.query("div.tip-portlet", curPageElem).forEach(function(node){
            
            /*TIP_DOJO_NS*/dojo.addClass(node, 'wire-dnd-target-portlet');
			
			var wireDropTarget = new com.ibm.isclite.dnd.Target(node, { createTargetNode: false, accept: ['eventItem']});
			console.log("wireDropTarget created for "+node.id);
			try {
			  var pageId = node.modelObject.page.pageData.uid;
			  customizer.wireDropTargets[pageId].push(wireDropTarget);
			} catch(e) {
				
			}
		});
	},
	
	setupWiresDragAndDropForCurrentPage: function() {
	  this.setupWiresDragAndDrop(IscPages.getPageElementById( IscPages.currentPageId ));
	},

	setupPorltetWiresDragAndDrop: function(node){
            /*TIP_DOJO_NS*/dojo.require("com.ibm.isclite.data.custom.eventsandwires.WireDNDManager");
            /*TIP_DOJO_NS*/dojo.require("com.ibm.isclite.dnd.Target");
            /*TIP_DOJO_NS*/dojo.addClass(node, 'wire-dnd-target-portlet');
			var wireDropTarget = new com.ibm.isclite.dnd.Target(node, { skipForm: true, createTargetNode: false, accept: ['eventItem']});
			
			try {
			  var pageId = node.modelObject.page.pageData.uid;
			  if (typeof this.wireDropTargets[pageId] == "undefined" || this.wireDropTargets[pageId] == null) {
			    this.wireDropTargets[pageId] = new Array();
			  }
			  
			  this.wireDropTargets[pageId].push(wireDropTarget);
			} catch(e) {
				
			}
    },
    
  clearWiresDragAndDrop: function( curPageElem ) {
	  try {
			  var pageId = curPageElem.modelObject.pageData.uid;
			  if (!this.wireDropTargets[pageId]) {
			    return;
			  }
			  
			  var dropTarget = null;
			  while(dropTarget = this.wireDropTargets[pageId].pop()) {
			  	dropTarget.destroy();
			  	console.log('destroying dropTarget');
			  }
			  console.log("destroying this.wireDropTargets[pageId]");
			  delete this.wireDropTargets[pageId];
		} catch(e) {
		    this.wireDropTargets[pageId] = null;
		}
		
		dojo.query("div.tip-portlet", curPageElem).forEach(function(node){
        dojo.removeClass(node, 'wire-dnd-target-portlet');
        console.log('removing wire-dnd-target-portlet');
		});
	},
	
	clearWiresDragAndDropForCurrentPage: function() { 
	  this.clearWiresDragAndDrop(IscPages.getPageElementById( IscPages.currentPageId ));
	},
	/*--- end setup wires drag and drop code ---*/
    
     hideShowEvents : function (portlet_div_id) {
		iscPopupMenuHide();
		var iscPortlet = dojo.byId(portlet_div_id);
		if(!iscPortlet)
			return;
		var portletDataObject = iscPortlet.modelObject.portletData;
		
		var pii = portletDataObject.basePii;
		
        //in new page use the map to get the correct pii
        // when editing page the map is empty
        //249145, changed to use the oid to get the pwi.
        var oid = portletDataObject.oid;
        if(piiToPWIMap[oid]){
     	    pii = piiToPWIMap[oid];
        }
		
		customizer.piiContainerArray.push(pii);
		var id = pii+"_portlet_events_dijit";
		var portletContent;
		if(iscPortlet.modelObject.page.isFreeformPage) {
			portletContent = dijit.byId(iscPortlet.id).containerNode;
		}
		else {
			portletContent = dojo.byId(portletDataObject.oid+"_portlet_content");
		}
		
		var eventsTable  = /*TIP_DOJO_NS*/dijit.byId(id);

		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
		var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId);
		var eventStore = storeManager.getEventsStore();
		
		if(!eventsTable){
			var nodeRef = document.createElement("div");
			var parentNode = portletContent.parentNode;
			parentNode.appendChild(nodeRef);
			nodeRef.id=pii+"_portlet_events_node";
			//customizer.rescaleRelativePage(currentPageDiv);  //249132, comment this line out so the event table won't become too narrow.
			eventsTable = new com.ibm.isclite.dijit.custom.events.Events( {id:id,uniquePageName:uniquePageName,store:eventStore,pii:pii,
			publishTabLabel:eventsAndWiresNls.events.publishTabLabel,
			subscribeTabLabel:eventsAndWiresNls.events.subscribeTabLabel, 
			eventDescriptionLabel:eventsAndWiresNls.events.eventDescriptionLabel,
			enableTitle:eventsAndWiresNls.events.enableTitle,
			publishedEventsDescriptionLabel :   eventsAndWiresNls.events.publishedEventsDescriptionLabel,
		    subscribedEventsDescriptionLabel:  eventsAndWiresNls.events.subscribedEventsDescriptionLabel,
			eventTitle:eventsAndWiresNls.events.eventTitle,
            noEventsLabel:eventsAndWiresNls.events.eventsNone}, nodeRef);
    		eventsTable.startup();
			eventsTable.onHide();
		}
		
		// ens: I don't understand what this block of code is doing. A comment describing what unusual condition
		// this is taking care of would have been nice. Intuitively, the if should never be true, but if it ever is
		// it must be because of a bizarre circumstance I don't understand. Becuase of that, I'm not going to delete it.
		// Prior to my edit, the dojo.query was looking for "table:first-child". Since this code was written, a <script>
		// tag was added between the parent node and the content table, so the query was returning some other table later in the DOM.
		// I changed the selector on the query so the first node returned is the content table.
		// Hopefully, this doesn't break whatever workaround this initially intended to fix.
		// ens: added - don't do this if it's the freeform page. 
		if(iscPortlet.modelObject.page.isFreeformPage) { 
			var eventsTableParentNode = eventsTable.domNode.parentNode;
	        var oldPortletContent = dojo.query( 'table', eventsTableParentNode )[0];
	        if(oldPortletContent!=portletContent){
	            //move dijit to new open instance
	            //disconect
	            eventsTableParentNode.removeChild(eventsTable.domNode);
				//display old portlet content
	            oldPortletContent.style.display="";
				//move
	            var parentNode = portletContent.parentNode;
	            parentNode.appendChild(eventsTable.domNode);
	        }
		}

		var div = eventsTable.domNode;
		eventsTable.showHide();
        if(portletContent.style.display=="none"){
        	// just hid the eventsTable, so the events button is un-selected
        	// TODO: I should be able to ask the eventsTable it's state, and the button should be easier to find
        	dojo.query("a[name=IscPortletEvents]", iscPortlet).forEach(function(n) {
        		dojo.attr(n, "aria-pressed", "false");
        	});
			portletContent.style.display="";
		}else{
			// just displayed the eventsTable
        	dojo.query("a[name=IscPortletEvents]", iscPortlet).forEach(function(n) {
        		dojo.attr(n, "aria-pressed", "true");
        	});
			portletContent.style.display="none";
        }
 
	},
	// convert px pages to relative that use pixels and don't rely on browser flow
	makePageRelative: function( pageDiv ) {
		var METHODNAME = "makePageRelative ";
		//console.log( METHODNAME + "Entry" );

		//250381
		iscPortlet.holdResizeEvents = true;
		try {

        // yangdong code here, get the page maximized and restore status. for solving maximized
        // portlet not shown when apply Paul's performance code
		var pageMaximized = this.isPageContainsMaximizedPortlet( pageDiv.id );
        var bRestore = (customizer.restoredPortlet == null) ? false : true ;
        // end yangdong code

		 var oldWidth = pageDiv.getAttribute( "relPageWidth" );
		 var oldHeight = pageDiv.getAttribute( "relPageHeight" );
		 var curWidth = window.frameElement.clientWidth;
		 var curHeight = window.frameElement.clientHeight;
		 //console.log( "makePageRelative: OldSize: " + oldWidth + "/" + oldHeight + ", CurSize: " + curWidth + "/" + curHeight );
		 if(0 == curHeight) {
			//console.log("makePageRelative: no frame height, try back later");
			window.setTimeout(function(){customizer.makePageRelative(pageDiv)}, 200);
			return;
		 }

        // yangdong modified code here, check if page has maximized portlet or is a restore action
        // force to fire resize event, this will cause performance down. need to figure out and
        // performance improve when there is maximized portlet in page
        if ( pageMaximized == true || bRestore == true ) { // force to fire resize event
        }
		else if( oldWidth == curWidth && oldHeight == curHeight ) {
			 //console.log( "makePageRelative: aborting because page is already relative to the current size" );
			 return;  
		 }
		 pageDiv.setAttribute( "relPageWidth", curWidth );
		 pageDiv.setAttribute( "relPageHeight", curHeight );

		// make sure empty windows occupy the allotted space
		customizer.showEmptyWindows( pageDiv );
		var rootTable = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if (rootTable == null){
			var freeformContent = /*TIP_DOJO_NS*/dojo.byId(IscPages.currentPageId + "FreeformContent");
			//console.log("make page relative");
			//console.log(freeformContent);
	    	var vp = /*TIP_DOJO_NS*/dojo.dnd.getViewport();
	    	/*TIP_DOJO_NS*/dojo.style(freeformContent, {height: vp.h + "px", width: vp.w + "px"});
	    	return;
		}
		/*TIP_DOJO_NS*/dojo.removeClass( rootTable, 'isc-layout-stretchy-root-table' );
		/*TIP_DOJO_NS*/dojo.addClass( rootTable, 'isc-layout-root-table' );
		pageDiv.style.paddingRight = '0px';
		rootTable.style.marginBottom = '0px';
		var rootTableSize = customizer.getRootTableSize( pageDiv );
		var missingWidths = false;
		var missingHeights = false;
		var portlets = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', pageDiv );

		for ( var i=0; i<portlets.length; i++ ) {
			// find any portlets without sizes to see if this is old style percent page
			var w = parseInt( portlets[i].parentNode.style.width );
  			var h = parseInt( portlets[i].parentNode.style.height );
			if ( isNaN( w ) ) {
				missingWidths = true;
			}
			if ( isNaN( h ) ) {
				missingHeights = true;
			}
		}
		if ( ! pageDiv.modelObject.pageData.percentsSet ) {
			var area = customizer.getContentAreaSize( pageDiv );
			var mw = ( area.w / rootTableSize.w );
			var mh = ( area.h / rootTableSize.h );
			var processingPortlet = null;
			var processingPortletParent = null;
			for ( var i=0; i<portlets.length; i++ ) {
				processingPortlet = portlets[i];
				processingPortletParent = processingPortlet.parentNode;
				if ( ! missingWidths ) {
					var w = parseInt( processingPortletParent.style.width );
					processingPortletParent.style.width = Math.floor( w * mw ) + 'px';
				}
				if ( ! missingHeights ) {
					var h = parseInt( processingPortletParent.style.height );
					processingPortletParent.style.height = Math.floor( h * mh ) + 'px';
				}
			}
			rootTableSize = customizer.getRootTableSize( pageDiv ); // recalc root table size
		}

// modified by dyang, we need to get this value in the early begining of this function
//		var pageMaximized = this.isPageContainsMaximizedPortlet( pageDiv.id );

		// calculate the inital percents and attach them to the portlets
		for ( var i=0; i<portlets.length; i++ ) {
			if ( pageMaximized && !this.isPortletMaximized( portlets[i].parentNode.id ) ) {
				// we do not want to calculate portlet percent if page has maximized
				// portlet and this is not the maximized portlet. This will retain the
				// percent in the portlet
				continue;
			} else {
				customizer.calcRelativePortletPercent( portlets[i].parentNode, rootTableSize, missingWidths, missingHeights );
			}
		}
 		if ( /*TIP_DOJO_NS*/dojo.isIE ) { // work around IE rendering bug
 			var windows = /*TIP_DOJO_NS*/dojo.query( 'td.isc-layout-window', rootTable );
 			for ( var i=0; i<windows.length; i++ ) {
 				windows[i].style.height = '1px';
 				windows[i].style.filter = '';
 			}
 		}

		// change container classes so it doesn't act like a noSize page
		var containers = /*TIP_DOJO_NS*/dojo.query( 'table.isc-layout-stretchy-container', rootTable );
		for ( var i=0; i<containers.length; i++ ) {
			/*TIP_DOJO_NS*/dojo.removeClass( containers[i], 'isc-layout-stretchy-container' );
			/*TIP_DOJO_NS*/dojo.addClass( containers[i], 'isc-layout-container' );
		}

		// convert the the percents from above into actual pixel sizes
		customizer.rescaleRelativePage( pageDiv );
		// restore any temp sizings still held in memory
		// defect 256135, PTE TBSM 1315 : Aditya Seth : added another condition "!pageMaximized" in the following IF condition
		if ( !pageMaximized && customizer.tempResizeStore[pageDiv.modelObject.pageData.uid] ) {
			customizer.restorePortletSizes( pageDiv );
		}
		// set marker flag
		if(!pageDiv.modelObject.pageData.preMaximized) {	// don't overwrite it if preMax data has already been saved away
			pageDiv.modelObject.pageData.preMaximized = {percentsSet: pageDiv.modelObject.pageData.percentsSet, noSize: pageDiv.modelObject.pageData.noSize };
		}
		pageDiv.modelObject.pageData.percentsSet = true;
		pageDiv.modelObject.pageData.noSize = false;

		/*
		var oldWidth = pageDiv.getAttribute( "relPageWidth" );
		var oldHeight = pageDiv.getAttribute( "relPageHeight" );
		var curWidth = window.frameElement.clientWidth;
		var curHeight = window.frameElement.clientHeight;
		//console.log( "makePageRelative: OldSize: " + oldWidth + "/" + oldHeight + ", CurSize: " + curWidth + "/" + curHeight );
		if( top.Frameset.DOPROTOTYPE && oldWidth == curWidth && oldHeight == curHeight ) {
			//console.log( "makePageRelative: Sending no resize events - page size has not changed" );
		}
		else {
			if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer initializing relative page' );
		}
		pageDiv.setAttribute( "relPageWidth", curWidth );
		pageDiv.setAttribute( "relPageHeight", curHeight );
		*/

		} //250381
    catch(e){
      //ensure IE executes the finally section
    }
		finally {
			iscPortlet.holdResizeEvents = false;
		}

		if ( iscPortlet && iscPortlet.sendResizeEvent ) iscPortlet.sendResizeEvent( 'customizer initializing relative page' );
	},
	getContentAreaSize: function( pageDiv ) {
		var METHODNAME = "getContentAreaSize ";
		var viewPort = /*TIP_DOJO_NS*/dojo.dnd.getViewport();
		//246695 - WireGUI:Portlet resize is unexpected.
		//When refresh, the viewport does not existed yet, so use the pageDiv as the view port.
		if (viewPort == null  || viewPort.h == 0)
			viewPort = /*TIP_DOJO_NS*/dojo.coords(pageDiv);
		//End 246695 - WireGUI:Portlet resize is unexpected.
		var size = {};
		size.w = viewPort.w - 16;
		var rootTable = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		var top = 0;
		if (rootTable != null)
			top = /*TIP_DOJO_NS*/dojo.coords( rootTable ).t;
		//lets check to see if the table is not visible in the current viewport
		if (top > viewPort.h)
			top = 0;
		size.h = viewPort.h - top - 16;
		if(/*TIP_DOJO_NS*/dojo.hasClass(pageDiv, "tip-freeform-page")) {
			// this isn't quite right in ie, I sometimes get a horiz. scrollbar that scrolls 8px, but not always
			size.w += 16;
			size.h += 16;
		}
		//console.log( METHODNAME + ' returning: ', size.w, size.h );
		return size;
	},
	getRootTableSize: function( node ) {
		var pageDiv = customizer.getContainingPageDiv( node );
		var rootTable = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if (rootTable == null){
			return /*TIP_DOJO_NS*/dojo.coords(pageDiv);
		}
		rootTable.style.margin = '0px';
		var rootTableSize = /*TIP_DOJO_NS*/dojo.coords( rootTable.tBodies[0] );
		return rootTableSize;
	},
	calcRelativePortletPercent: function( portletDiv, rootTableSize, missingWidths, missingHeights ) {
		var METHODNAME = "calcRelativePortletPercent ";
		var pageDiv = customizer.getContainingPageDiv( portletDiv );
		if ( rootTableSize == undefined ) rootTableSize = customizer.getRootTableSize( portletDiv );
		var w = 0, h = 0, pw = 0, ph = 0;
		portletDiv.style.overflow = 'auto';
		if ( this.isPortletMaximized( portletDiv.id ) ) {
			// portlet is in maximized mode. Set percent to 100
			// if current portlet is maximized, and was back from the tab switch
			if (portletDiv.percent && portletDiv.percent.w == "100" && portletDiv.percent.h == "100" && portletDiv.savedPercent) return;
			portletDiv.savedPercent = portletDiv.percent;
			portletDiv.percent = { w: "100", h: "100" };
			return;
		} else if ( this.restoredPortlet && pageDiv.modelObject.isStateMaintained() ) {
			if ( portletDiv.savedPercent && this.restoredPortlet.portletId == portletDiv.id ) {
				// restore percent, no need to recalculate percent
				portletDiv.percent = portletDiv.savedPercent;
				portletDiv.savedPercent = null;
				return;
			} 
			//254636 --- restore code for the portlets to come back to original positions
			else if ( this.restoredPortlet.pageId == portletDiv.getAttribute("pageid") ) {
			if(portletDiv.style.width=="0px" &&  (portletDiv.style.height =="0px" || portletDiv.style.height == "1px")){
				portletDiv.percent=IscPages.getSavedPercents(portletDiv.id);
				IscPages.resetSavedPercents(portletDiv.id);
			}  
				// this portlet has been restored from Maximized state
				// Skip recalculate...
				return;
			}
		}
		if ( missingWidths ) {
			var size = iscPortlet.getPortletSize( portletDiv );
			pw = size.percents.w;
			w = Math.floor( rootTableSize.w * pw / 100 );
			/*248488 portletDiv.style.width = w + 'px'; */ /* console.log( METHODNAME + "Calling sizePortletDiv" ); */ customizer.sizePortletDiv( portletDiv, w, null );
		} else {
			w = parseInt( portletDiv.style.width );
			if ( isNaN( w ) ) {
				w = /*TIP_DOJO_NS*/dojo.contentBox( portletDiv.parentNode ).w;
				// console.log( '  calcRelativePortletPercent missing w for: ', portletDiv );
				// console.log( '     using w: ', w );
				/*248488 portletDiv.style.width = w + 'px'; */ /* console.log( METHODNAME + "Calling sizePortletDiv" ); */ customizer.sizePortletDiv( portletDiv, w, null );
			}
			pw = ( w / rootTableSize.w ) * 100;
		}
		if ( missingHeights ) {
			var size = iscPortlet.getPortletSize( portletDiv );
			ph = size.percents.h;
			h = Math.floor( rootTableSize.h * ph / 100 );
			/*248488 portletDiv.style.height = h + 'px'; */ /* console.log( METHODNAME + "Calling sizePortletDiv for missingHeights" ); */ customizer.sizePortletDiv( portletDiv, null, h );
		} else {
			h = parseInt( portletDiv.style.height );
			if ( isNaN( h ) ) {
				h = /*TIP_DOJO_NS*/dojo.contentBox( portletDiv.parentNode ).h;
				// console.log( '  calcRelativePortletPercent missing h for: ', portletDiv );
				// console.log( '     using h: ', h );
				/*248488 portletDiv.style.height = h + 'px'; */ /*console.log( METHODNAME + "Calling sizePortletDiv for !missingHeights" ); */ customizer.sizePortletDiv( portletDiv, null, h );
			}
			ph = ( h / rootTableSize.h ) * 100;
		}
		var pageDiv = customizer.getContainingPageDiv( portletDiv );
		if ( pageDiv && ! pageDiv.modelObject.pageData.percentsSet ) {
			// store global percent size if this is the first time
			// the page is loaded.  use these percent sizes later for restoring to
			// global size so that relative sizings don't get broken.
			var portletTable = /*TIP_DOJO_NS*/dojo.query( 'table[name="IscPortlet"]', portletDiv )[0];
			portletTable.modelObject.portletData.initialPercents = {};
			portletTable.modelObject.portletData.initialPercents[0] = pw;
			portletTable.modelObject.portletData.initialPercents[1] = ph;
		}
		// console.log( '  calcRelativePortletPercent - setting page percents ', pw, ph );
		portletDiv.percent = { w:pw, h:ph };
	},
	rescaleRelativePage: function( pageDiv ) {
		var METHODNAME = "rescaleRelativePage ";
		if (pageDiv.modelObject.pageData.layoutType == "Freeform")
			return;
		var portlets = dojo.query( 'table[name="IscPortlet"]', pageDiv );
		var contentsize = customizer.getContentAreaSize( pageDiv );
		for ( var i=0; i<portlets.length; i++ ) {
			var portletDiv = portlets[i].parentNode;
			if ( !portletDiv.percent ) {
				// portletDiv has no percent, recalculate percent
				customizer.calcRelativePortletPercent( portletDiv, contentsize );
			}
			var size = customizer.percentToPixels( portletDiv.percent, null, contentsize );
			customizer.sizePortletDiv( portletDiv, size.w, size.h);

		}
	},
	resizeTimer: 0,
	resizeDelay: 200,
	lastResize: {w: undefined, h: undefined},
	onWindowResize: function() {
		//console.log("customizer.onWindowResize");
		// in ie, the DOM's state hasn't necessarily been updated before we
		// start our resize calculations, which can cause problems, like the page
		// oscillating between 2 sizes in an endless resize loop.
		// the timeout lets the browser finish flowing the page and updating the DOM
		// by cancelling the timer each time I get here, we only do the real resize work
		// after the window stops changing size, say when the user is dragging the browser's
		// corner.
		// The call to sendResizeEvent is required here because we are handling windowResize 
		// asynchronously so it'sgeting executed after the original portletRezie event is fired.
		//
		// ens: decided to try this for all browsers to eliminate lots of resize events, 
		// this will help peformance, especially on complicated pages
		if(this.isResizing) 
			return;
//	TODO: uncomment to supress resize handling if the window hasn't changed size
// start resize change
		var sz = dojo.window.getBox();
		if(sz.w == this.lastResize.w && sz.h == this.lastResize.h) {
			console && console.log && console.log("onWindowResize with same size. bailing.");
			return;
		}
		//on IE, changing the zoom level to non default values causes an infinite loop - working it around here
		var zoom = (window.screen.deviceXDPI/96)*100;
		if(/*TIP_DOJO_NS*/dojo.isIE && zoom >= 100 && Math.abs(this.lastResize.w-sz.w) >= 11){
			return;
		}
		this.lastResize = sz;
// end resize change
		if(this.resizeTimer) {
			window.clearTimeout(this.resizeTimer);
		}
		this.resizeTimer = window.setTimeout(function() 
		{
			this.resizeTimer = 0;
			customizer.windowResize();
		}, this.resizeDelay);
	},
	isResizing: false,
	windowResize: function() {
		try {
			customizer.isResizing = true;
		
			//console.log( "customizer.windowResize" );
			var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
			if ( pageDiv == null || typeof pageDiv == undefined ) {
				//console.log( "customizer.windowResize: page DOM is not finalized yet" );
				return false;
			}
			//252129, no-size page need to get the resize event as well,
			//so we should just skip the rescaleRelativePage() rather than return.
			//also moved rescaleRelativePage() into the else block below since it's not required by freeform
		  //if ( pageDiv.modelObject.isNoSizePage() ) return;
			//customizer.rescaleRelativePage( pageDiv );
			if(pageDiv.modelObject.getLayoutType() === "Freeform") {
				ibm.tivoli.tip.ffcustomizer.resize(IscPages.getPageElementById( IscPages.currentPageId ));
			}
			else {
			  //252129 begin
			  if ( !pageDiv.modelObject.isNoSizePage() ) {
			    customizer.rescaleRelativePage( pageDiv );
		    }
		    //252129 end
				iscPortlet.sendResizeEvent('customizer.windowResize');	// everything needs to be resized
			}
		}
		finally {
			customizer.isResizing = false;
		}
	},
	percentToPixels: function( percent, pageDiv, contentsize ) {
		if ( ! pageDiv == null ) contentsize = customizer.getContentAreaSize( pageDiv );
		var w = Math.floor( percent.w * contentsize.w / 100 );
		var h = Math.floor( percent.h * contentsize.h / 100 );
		return { w: w, h: h };
	},
    init: function() {
        // connect to resize events
		if ( ! customizer.windowResizeEvent ) {
            // this handles browser resizes or navigation area collapsing/restoring
			customizer.windowResizeEvent = /*TIP_DOJO_NS*/dojo.connect( window, 'onresize', customizer, "onWindowResize" );

		}
    },
	getCategorizedCells: function( table ) {
		var cells = [];
		var used = { w:0, h:0 };
		var isRow = ( table.rows.length == 1 );
		// fixed dimension for rows is row height and for cols is tbody width
		if ( isRow ) {
			used.h = /*TIP_DOJO_NS*/dojo.coords( table, false ).h;
		} else {
			used.w = /*TIP_DOJO_NS*/dojo.coords( table, false ).w;
		}
		for ( var r=0; r<table.rows.length; r++ ) {
			for ( var c=0; c<table.rows[r].cells.length; c++ ) {
				var cell = table.rows[r].cells[c];
				if( /*TIP_DOJO_NS*/dojo.hasClass( cell, 'isc-layout-window' ) ) {
					// this is a window cell containing a portlet
					cell.isPortlet = true;
					cells.push( cell );
				} else if ( cell.className == 'isc-layout-sizebar-vertical' ) {
					// this is a vertical sizer
					var w = /*TIP_DOJO_NS*/dojo.coords( cell ).w;
					if ( w == 25 ) { // workaround size bug in FF2
						w = 7;
					} else if ( w == 24 ) {
						w = 6;
					}
					used.w += w;
				} else if ( cell.className == 'isc-layout-sizebar-horizontal' ) {
					// this is a horizontal sizer
					var h = /*TIP_DOJO_NS*/dojo.coords( cell ).h;
					if ( h == 25 ) { // workaround size bug in FF2
						h = 7;
					} else if ( h == 24 ) {
						h = 6;
					}
					used.h += h;
				} else if ( cell.className == '' ) {
					// this should be a cell containing another layout table
					cell.isPortlet = false;
					cells.push( cell );
				}
			}
		}
		return { cells: cells, used: used };
	},
	fixPortletSizes: function( pageDiv ) {
		/* How this recursion works:
		 *  I am always told the total of my long dimension from above - I
		 *  always have to reconcile it I am either asked what my short
		 *  dimension is or told what to make it I need to make all my parts
		 *  match the short dimension (their long dim) that I know or am given
		 *  To reconcile my long dimension, I ask all but the last one what
		 *  their short dim is.  The last one I tell what to be.
		 */
		if ( this.isPageContainsMaximizedPortlet( pageDiv.id ) ) return; // don't do this on a max'd portlet
		var rootTable = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-root-table, table.isc-layout-stretchy-root-table", pageDiv )[0];
		if (rootTable == null){
	    	return;	// a freeform page
		}
		var size = customizer.getContentAreaSize( pageDiv );
		if ( rootTable.rows.length == 1 ) {
			// work around a quirk in ISC page aggregation that leaves an extra table
			var nextTable = /*TIP_DOJO_NS*/dojo.query( "table.isc-layout-container, table.isc-layout-stretchy-container", rootTable )[0];
			if ( nextTable && nextTable.rows.length == 1 ) rootTable = nextTable;
		}
		
		//rootTable.style.width = size.w + 'px';
		//rootTable.style.height = size.h + 'px';
		/*
		rootTable.tBodies[0].style.width = size.w + 'px';
		rootTable.tBodies[0].style.height = size.h + 'px';
		*/
		// start the recursion
		if ( rootTable.rows.length == 1 ) {  // if it's a row container
			processThePortlets( rootTable, size.w, size.h );
		} else {
			processThePortlets( rootTable, size.h, size.w );
		}
		// recursion function for finding the portlets and setting sizes
		function processThePortlets( table, l, s ) { // long dim (required) , short dim (optional)
			var METHODNAME = "processThePortlets ";
			var isRow = ( table.rows.length == 1 );
			var cells = customizer.getCategorizedCells( table );
			var all = cells.cells;
			var last = all.length > 0 ? all[all.length - 1] : null;
			// if we are given short side we have to enforce it. otherwise enforce used size
			if ( s == null ) s = ( isRow ) ? cells.used.h : cells.used.w;
			// initialize with known used space
			var runningtotal = ( isRow ) ? cells.used.w : cells.used.h;
			var sz;
			for ( var i=0; i<(all.length - 1); i++ ) { // all but the last (or only) one
				if ( all[i].isPortlet ) {
					var div = /*TIP_DOJO_NS*/dojo.query( 'div[name="PortletFragment"]', all[i] )[0];
					if ( isRow ) {
						// portlet widths are already accounted for, just set height
						/* div.style.height = ( s - 2 ) + 'px'; */ /* console.log( METHODNAME + "Calling sizePortletDiv with isRow" ); */ 
						customizer.sizePortletDiv( div, null, ( s - 2 ) );
						sz = parseInt( div.style.width );
						if(!isNaN(sz))
							runningtotal += sz;
					} else {
						// portlet heights are already accounted for, just set width
						/* div.style.width = ( s - 2 ) + 'px'; */ /* console.log( METHODNAME + "Calling sizePortletDiv with !isRow" ); */ 
						customizer.sizePortletDiv( div, ( s - 2 ), div.style.height );
						
						/*
						 * 255249:
						 * For minimized portlet, its style.height will be an empty string "",
						 * which is obviously not wanted. Instead, use its height when it's in
						 * "normal"  window state here. It's stored in prevHeight property.
						 * (Done in customizer.sizePortletDiv function).
						 */
						var divHeight = customizer.isPortletMinimized(div) ? div.prevHeight : div.style.height;
						sz = parseInt( divHeight );
						
						if(!isNaN(sz))
							runningtotal += sz; 
					}
				} else {
					var nextTable = /*TIP_DOJO_NS*/dojo.query( 'table:first-child', all[i] )[0];
					// next container is orthogonal - pass in its long side as this one's short side
					// add its short dimension to the running total
					//dont assume that next container is always orthogonal, check and then process
					var isNextContainerRow = nextTable.rows.length;
						
					if(isNextContainerRow == 1 && isRow){	
						//row container inside row container
						sz = processThePortlets( nextTable, (all[i].clientWidth - 2 ), null ).l;
					}else if(isNextContainerRow != 1 && !isRow){
						//column container inside column container
						sz = processThePortlets( nextTable, ( all[i].clientHeight - 2 ), null ).l;
					}else
					{
						//orthogonal
					sz = processThePortlets( nextTable, ( s - 2 ), null ).s;
					}
					if(!isNaN(sz))
						runningtotal += sz 
					if ( /*TIP_DOJO_NS*/dojo.isIE ) all[i].style.height = '1px'; // work around IE bug
				}
			}
			// set the size on the last cell
			var remaining = l - runningtotal;
			if ( remaining < 0 ) {
				remaining = 0;
				//console.log( 'in fixPortletSizes: got negative remaining.. ' );
			}
			if(last) {
				if ( last.isPortlet ) {
					var div = /*TIP_DOJO_NS*/dojo.query( 'div[name="PortletFragment"]', all[i] )[0];
					if ( isRow ) {
						/*
					div.style.height = ( s - 2 ) + 'px';
					div.style.width = remaining + 'px';
						 */
						/* console.log( METHODNAME + "Calling sizePortletDiv" ); */ customizer.sizePortletDiv( div, remaining, ( s - 2 ) );
					} else {
						/*
					div.style.width = ( s - 2) + 'px';
					div.style.height = remaining + 'px';
						 */
						/* console.log( METHODNAME + "Calling sizePortletDiv" ); */ customizer.sizePortletDiv( div, ( s - 2 ), remaining );
					}
				} else {
					var nextTable = /*TIP_DOJO_NS*/dojo.query( 'table:first-child', all[i] )[0];
					processThePortlets( nextTable, ( s -2 ), remaining );
					if ( /*TIP_DOJO_NS*/dojo.isIE ) last.style.height = '1px'; // work around IE bug
				}
			}
			return { l:l, s:s };
		}
	},
	addMaximizedPortlet: function(portletId) {
		// portletId - contains 2 vars: portletId and pageId
		if ( !this.isPortletMaximized( portletId.portletId ) ) {
			this.maximizedPortlets.push( portletId );         
		}                                          
	},        
	isPortletMaximized: function( portletId ) {
		for ( var i = 0; i < this.maximizedPortlets.length; i++ ) {
			if ( this.maximizedPortlets[i].portletId == portletId ) {
				return true;
			}
		}
		return false;                                                               
	},
	
	/**
	 *  TODO: to be consistent with isPortletMaximized(),
	 *  change parameter element(Object) to portletID(String).
	 */
	isPortletMinimized: function(element) {
		if (!element || !element.id) {
			return false;
		}
		
		var portletID = 'iscPortlet_;' + element.id + ';view';
		var portletDIV = document.getElementById(portletID);
		
		return (
			portletDIV &&
			portletDIV.modelObject &&
			portletDIV.modelObject.portletData &&
			portletDIV.modelObject.portletData.state === "minimized"
		);
	},
	
	isPageContainsMaximizedPortlet: function(pageId) {
		for ( var i = 0; i < this.maximizedPortlets.length; i++ ) {
			if ( this.maximizedPortlets[i].pageId == pageId ) {
				return true;
			}
		}
		return false;
	},
	setRestoredPortlet: function(portletId) {
		if ( this.isPortletMaximized(portletId) ) {
			// portlet restored, set the var and remove from maximizedPortlet array
			// we use this restoredPortlet when we setup customizer
			this.restoredPortlet = this.removeMaximizedPortlet(portletId);
		}
	},
	removeMaximizedPortlet: function(portletId) {
		var maxPortlet = null;
		for ( var i = 0; i < this.maximizedPortlets.length; i++ ) {
			if ( this.maximizedPortlets[i].portletId == portletId ) {
				maxPortlet = this.maximizedPortlets[i];
				this.maximizedPortlets.splice(i, 1);
				break;
			}
		}
		// ens: I'm not completely sure this is correct, but it works.
		// restoring a portlet after maximizing it didn't return it to
		// its previous size in noSize pages.  Take care of that here
		// by stripping the size style away. Part of 248762
		if(maxPortlet) {
			var pg = /*TIP_DOJO_NS*/dojo.byId(maxPortlet.pageId);
			if(pg && pg.modelObject.pageData.preMaximized) {
				pg.modelObject.pageData.percentsSet = pg.modelObject.pageData.preMaximized.percentsSet;
				pg.modelObject.pageData.noSize = pg.modelObject.pageData.preMaximized.noSize;
				delete pg.modelObject.pageData.preMaximized;

				if(pg.modelObject.pageData.noSize) {
					/*TIP_DOJO_NS*/dojo.style(maxPortlet.portletId, {height:"", width:"",overflow:""});
				}
			}
		}
		return maxPortlet;
	},
	resizePortletStart: function(event){
		//console.log("customizer.resizePortletStart");
		customizer.portletSizeOriginX = event.screenX;
		customizer.portletSizeOriginY = event.screenY;
		var portletId = null;
		if (/*TIP_DOJO_NS*/dojo.isIE){
			portletId = event.srcElement.parentNode.id;
		}else{
			portletId = event.target.parentNode.id;
		}
		customizer.portletOrigWidth = /*TIP_DOJO_NS*/dojo.byId(portletId).clientWidth;
		customizer.portletOrigHeight = /*TIP_DOJO_NS*/dojo.byId(portletId).clientHeight;
		var pageuid = IscPages.getPageObjectById(IscPages.currentPageId).pageData.uid;
		var freePageDiv = /*TIP_DOJO_NS*/dojo.byId(pageuid + "FreeformContent");
		customizer.portletResizeEventTarget = document.createElement( 'DIV' );

		/*TIP_DOJO_NS*/dojo.style(customizer.portletResizeEventTarget, {
			cursor: customizer.isRTL ? 'ne-resize' : 'se-resize',
			position: "absolute", 
			top: "0px", left: "0px",
			width: "100%",
			height: freePageDiv.clientHeight + "px",
			zIndex: 10000
		});
		/*TIP_DOJO_NS*/dojo.place( customizer.portletResizeEventTarget, freePageDiv, 'first' );
		
		/*TIP_DOJO_NS*/dojo.connect(customizer.portletResizeEventTarget,"onmousemove",function(event){customizer.resizePortletMove(event,portletId);});
		/*TIP_DOJO_NS*/dojo.connect(customizer.portletResizeEventTarget,"onmouseup", function(event){customizer.resizePortletUp(event, portletId);});
		/*TIP_DOJO_NS*/dojo.connect(customizer.portletResizeEventTarget,"onmouseout",function(event){customizer.resizePortletUp(event, portletId);});
		/*TIP_DOJO_NS*/dojo.stopEvent(event);
	},
	resizePortletMove: function(event,portletId){
		//console.log("customizer.resizePortletMove");
		var portletFragment = /*TIP_DOJO_NS*/dojo.byId(portletId);
		
		var deltaWidth = event.screenX - customizer.portletSizeOriginX;
		var deltaHeight = event.screenY - customizer.portletSizeOriginY;
		
		var currentTempWidth = customizer.portletOrigWidth + deltaWidth;
		var currentTempHeight = customizer.portletOrigHeight + deltaHeight;
		if (currentTempHeight < 20){
			currentTempHeight = 20;
		}
		if (currentTempWidth < 20){
			currentTempWidth = 20;
		}
		portletFragment.style.height = currentTempHeight + "px";
		portletFragment.style.width = currentTempWidth + "px"; 
		/*TIP_DOJO_NS*/dojo.stopEvent(event);
	},
	resizePortletUp: function(event, portletId){
		//console.log("customizer.resizePortletUp");

		/*TIP_DOJO_NS*/dojo._destroyElement(customizer.portletResizeEventTarget);
		/*TIP_DOJO_NS*/dojo.stopEvent(event);
		if ( iscPortlet && iscPortlet.sendResizeEvent ){
			iscPortlet.sendResizeEvent( 'change portlet size' );
		}
		customizer.sendPortletSize(/*TIP_DOJO_NS*/dojo.byId(portletId));

		customizer.initResizeSaveCancel(IscPages.getPageElementById(IscPages.currentPageId));
	},
	changeResizeBlockLocation: function(portletId){
		var resizeblock = /*TIP_DOJO_NS*/dojo.byId("sizeChange" + portletId);
		if (resizeblock != null) {
			var portletFragment = /*TIP_DOJO_NS*/dojo.byId(portletId);
			resizeblock.style.bottom = (0 - portletFragment.scrollTop) + "px";
			if (customizer.isRTL){
				resizeblock.style.left = (0 - portletFragment.scrollLeft) + "px";
			}else{
				resizeblock.style.right = (0 - portletFragment.scrollLeft) + "px";
			}
		}
	},
	toggleFullScreen: function(portletId, menuItem) {
		iscPopupMenuHide();
		
		var isFullscreen = menuItem.checked;
		var portletDiv = /*TIP_DOJO_NS*/dojo.byId(portletId);
		var pageId = portletDiv.getAttribute("pageid");
		var portletTable = /*TIP_DOJO_NS*/dojo.byId("iscPortlet_;" + portletId + ";view");
		var currPortletSz = portletTable.modelObject.portletData.globalPortletSize;

		if(isFullscreen) {
			// cache the portlet's current non-fullscreeen size
			var box = /*TIP_DOJO_NS*/dojo.coords(portletDiv);
			currPortletSz[0] = box.w;
			currPortletSz[1] = box.h;
			currPortletSz[2] = box.l;
			currPortletSz[3] = box.t;
			/*TIP_DOJO_NS*/dojo.addClass(portletDiv, "isc-portlet-fullscreen");
			/*TIP_DOJO_NS*/dojo.style(portletDiv, {top: "0px", left: "0px"}); // w and h will be handled later in fullscreenResizeHandler
		}
		else {
			// put the portlet back to how it was before being set to full page
			/*TIP_DOJO_NS*/dojo.style(portletDiv, {width: currPortletSz[0] + "px", height: currPortletSz[1] + "px", left: currPortletSz[2] + "px", top: currPortletSz[3] + "px"});
			customizer.sizePortletDiv( portletDiv, null, /*TIP_DOJO_NS*/dojo.style( portletDiv, "height" ) );
			/*TIP_DOJO_NS*/dojo.removeClass(portletDiv, "isc-portlet-fullscreen");
		}
		iscPortlet.sendResizeEvent('customizer.toggleFullCcreen');
		this.updateFullscreen(portletId, isFullscreen);
	},
	updateFullscreen: function( windowId, isFullscreen ) {
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );		
		
		// normal customizer mode saving
		var uid = currentPageDiv.modelObject.pageData.tid;
		var uniquePageName = currentPageDiv.modelObject.pageData.uniquePageName;
		if (uniquePageName.indexOf("_") > 0 && uniquePageName.indexOf("banner.isc.welcome") < 0)
			uniquePageName = uniquePageName.substring(0,uniquePageName.indexOf("_"));
		var url = contextRoot + '/customizer.do?action=updatefullscreen'
				+ '&moduleRef=' + currentPageDiv.modelObject.pageData.moduleRef
				+ '&pageId=' + uniquePageName
				+ '&windowId=' + windowId
			        + '&XSS=' + top.window.XSS
				+ '&fullscreen=' + isFullscreen.toString();
		if ( uid ) url += '&uid=' + uid;
		url = encodeURI( url );
		/*TIP_DOJO_NS*/dojo.xhrGet( {
			url: url,
			load: function( type, data, evt ) { },
			handleAs: "text"
		} );		
	},
	fullscreenResizeHandler: function() {
		/*TIP_DOJO_NS*/dojo.query("div.isc-portlet-fullscreen").forEach(function(portletDiv) 
		{
			if(console && console.log) console.log("customizer.fullscreenResizeHandler resizing portlet " + portletDiv.id);
			var cb = /*TIP_DOJO_NS*/dojo.contentBox(portletDiv.offsetParent),
				bx = /*TIP_DOJO_NS*/dojo._getBorderExtents(portletDiv);
			customizer.sizePortletDiv( portletDiv, cb.w-bx.w, cb.h-bx.h );
		});
	}	
};
customizer.init();

function customizerModify(modifyAction, uid){
	/*
	250176	Do not send closePage event to page on customizerModify, just on customizerSave.
			customizerModify is used when switching back to the page settings page without closing the page being customized.
			Sending closePage event in this scenario tells portlets using dojo widgets (e.g. Change Your Password portlet) to unload their widgets, which is not desired.

	// TBSM 1116 - send closePage event after selecting which portlets to put on a page and clicking save
	parent.detail.EventBroker.unsubscribePortletsInPage(uid);   // Send event to page
	*/
	
	var eventsAndWiresUW = {};

    if ( IscPages && IscPages.getPageElementById ) {
        var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
	    var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
	
		var div = /*TIP_DOJO_NS*/dijit.byId(uniquePageName+"_Wires_Table_ID").domNode;
		div.style.display="none";

		var buttonId =uniquePageName +"_wires_button_id";
		var wireButton = /*TIP_DOJO_NS*/dojo.byId(buttonId);

        if (wireButton) {
            /*TIP_DOJO_NS*/dojo.removeClass(wireButton, 'isc-table-toolbar-buttonbar-hide' );
            /*TIP_DOJO_NS*/dojo.addClass(wireButton,'isc-table-toolbar-buttonbar');

        }

		var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId); 
        if (storeManager){
            eventsAndWiresUW = storeManager.getUnitOfWork(modifyAction);
        }
	}
    
    customizerRedirect(modifyAction,uid,eventsAndWiresUW);
}

function customizerSave(saveAction,uid){

	// TBSM 1116 - send closePage event after selecting which portlets to put on a page and clicking save
	// 249119f_1 The server could be in maintenance mode and refuse to save the page - this function will be done only when the server response actually removes the page from the DOM, in Page.prototype.replace()
	//parent.detail.EventBroker.unsubscribePortletsInPage(uid);   // Send event to page

	
	//If there is a Portlet Picker on the page, show error message and do not proceed with saving
	var currentPageDiv = IscPages.getPageElementById(IscPages.currentPageId);

	/*If there is a Portlet Picker on the page, show error message and do not proceed with saving
	var thePickers = / *TIP_DOJO_NS* /dojo.query( "#thepicker", currentPageDiv );
	if( thePickers.length > 0)
	{
		var errorMessageTable = / *TIP_DOJO_NS* /dojo.query( "#errorMessageTable", currentPageDiv );
		errorMessageTable.style.display = "";
		return;
	}
	*/

	var eventsAndWiresUW = {};

    if ( IscPages && IscPages.getPageElementById ) {
        var pageDiv = currentPageDiv;
	    var uniquePageName = pageDiv.modelObject.pageData.uniquePageName;
		var storeManagerId = uniquePageName+"_store_id";
	
		var div = /*TIP_DOJO_NS*/dijit.byId(uniquePageName+"_Wires_Table_ID").domNode;
		div.style.display="none";

		var buttonId =uniquePageName +"_wires_button_id";
		var wireButton = /*TIP_DOJO_NS*/dojo.byId(buttonId);

        if (wireButton) {
            /*TIP_DOJO_NS*/dojo.removeClass(wireButton, 'isc-table-toolbar-buttonbar-hide' );
            /*TIP_DOJO_NS*/dojo.addClass(wireButton,'isc-table-toolbar-buttonbar');

        }

		var storeManager = /*TIP_DOJO_NS*/dijit.byId(storeManagerId); 
        if (storeManager){
            eventsAndWiresUW = storeManager.getUnitOfWork(saveAction);
        }
        
	}
	
	
	
	//209836 - don't leave customize mode, the user might want to go back and continue editing the layout	
	//250249, undo the fix for 209836. the scenario has changed as users won't go back after saving the page.
	// 249119f_1 Redo the fix - the server could be in maintenance mode and refuse to save the page - this function will be done only when the server response actually removes the page from the DOM, indicating a successful save, in Page.prototype.replace()
	//cleanCustomizerResources();
	customizerRedirect(saveAction,uid,eventsAndWiresUW);
	
	//249584, clear the temporary pii maps after submitting the new page.
	// 249119f_1 This function will be done only when the server response actually removes the page from the DOM, indicating a successful save, in Page.prototype.replace()
	//pwiToPiiMap = {};
	//piiToPwiMap = {};
}

function customizerCancelEditPage(cancelAction,uid){
	cleanCustomizerResources();
	customizerRedirectEditPage(cancelAction,uid);
}

function customizerRedirectEditPage(action,uid,eventsAndWiresUW){

	var pageIds = uid.split(";");
	var location = contextRoot + "/taskbar.do?pageID=" + pageIds[0] + "&moduleRef=" + pageIds[1] + "&ISC.PAGE_LEAVE_CUSTOMIZER=" + uid + '&XSS=' + top.window.XSS;
	if (pageIds.length > 2) {
		location += "&ISC.TID=" + pageIds[2];
	}
	if(eventsAndWiresUW){
        var eventsAndWiresArray = new Array();
        eventsAndWiresArray["eventsAndWiresUW"] = /*TIP_DOJO_NS*/dojo.toJson(eventsAndWiresUW);
	}

    SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);
}

function customizerCancelNewPage(cancelAction,uid){
	cleanCustomizerResources();
	customizerRedirectNewPage(cancelAction,uid);
}

function customizerRedirectNewPage(action,uid,eventsAndWiresUW){
	var location =contextRoot + "/taskbarfragment.do?"+action+"="+uid +"&XSS="+top.window.XSS;
	if(eventsAndWiresUW){
        var eventsAndWiresArray = new Array();
        eventsAndWiresArray["eventsAndWiresUW"] = /*TIP_DOJO_NS*/dojo.toJson(eventsAndWiresUW);
	}

    SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);
}

function customizerRedirect(action,uid,eventsAndWiresUW){
	var location =contextRoot + "/taskbarfragment.do?"+action+"="+uid + '&XSS=' + top.window.XSS;
	if(eventsAndWiresUW){
		//var eventsAndWiresUWJson = encodeURIComponent(dojo.toJson(eventsAndWiresUW)); 
		//location+="&eventsAndWiresUW="+eventsAndWiresUWJson;
        var eventsAndWiresArray = new Array();
        eventsAndWiresArray["eventsAndWiresUW"] = /*TIP_DOJO_NS*/dojo.toJson(eventsAndWiresUW);
	}

var pageDiv = IscPages.getPageElementById( IscPages.currentPageId );
var layoutType = pageDiv.modelObject.pageData.layoutType;

SMUtils.RequestFragmentCollection(location,null,eventsAndWiresArray);

}
function cleanCustomizerResources(){
	if ( IscPages && IscPages.getPageElementById ) {
        var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
        if ( customizer && customizer.leaveCustomizeMode ) {
                customizer.leaveCustomizeMode( currentPageDiv );
        }
	}
}

function globalPutPortletInCustomizeMode(oid) {
		var currentPageDiv = IscPages.getPageElementById( IscPages.currentPageId );
		var portletDiv = document.getElementById(oid);
		customizer.putPortletInCustomizeMode( portletDiv );
	}
